<id>
Advanced Username Color for YaBB 2.1
</id>

<version>
1.0a
</version>

<mod info>
This mod replace default Color to Membergroups Color in Username on BoardIndex, MessageIndex, Notification, Search Result, Topic Summary, 10 Most Recent Post and Subboard.

Installation:
1) Modify YaBB files using BoardMod or manually.
2) Load modified files to your server in ASCII mode.

Admin/ModList.pl (ASCII)
Sources/BoardIndex.pl (ASCII)
Sources/MessageIndex.pl (ASCII)
Sources/Display.pl (ASCII)
Sources/Notify.pl (ASCII)
Sources/Poll.pl (ASCII)
Sources/Post.pl (ASCII)
Sources/Recent.pl (ASCII)
Sources/Search.pl (ASCII)
</mod info>

<author>
Boris Tjuvanov (MF-B) and Jeffrey Man (Jet Li)
</author>

<homepage>
http://www.mf-b.ru and http://www.grafix-world.nl
</homepage>

<edit file>
Admin/ModList.pl
</edit file>

<search for>
### END BOARDMOD ANCHOR ###
</search for>

<add before>
 	$AdvancedUserColor = "Advanced_User_Color|Boris Tjuvanov (<a href=\"http://www.mf-b.ru\" target=\"_blank\">MF-B</a>) and Jeffrey Man (<a href=\"http://www.grafix-world.nl\" target=\"_blank\">jet Li</a>)|This mod set Username in Colors in BoardIndex, MessageIndex, Notification, View Votes, Recent Posts, Search and Subboard.|1.0a|August 23th, 2006";
	push (@installed_mods, "$AdvancedUserColor ");
</add before>

<edit file>
Sources/BoardIndex.pl
</edit file>

<search for>
				while ($tmpa = each(%moderators)) {
					&FormatUserName($tmpa);
					$showmods .= qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$tmpa}">$moderators{$tmpa}</a>, ~;
				}
</search for>

<replace>
				while ($tmpa = each(%moderators)) {
					$moderators{$tmpa} = qq~$link{$tmpa}~;
					$showmods .= qq~$moderators{$tmpa}, ~;
				}
</replace>

<search for>
					if ((${$uid.$lastposter}{'regdate'} && $messagedate > $registrationdate) || ${$uid.$lastposter}{'status'} eq "Administrator" || ${$uid.$lastposter}{'status'} eq "Global Moderator") {
						$lastposter = qq~<a href="$scripturl?action=viewprofile;username=$lastposter">${$uid.$lastposter}{'realname'}</a>~;
					} else {
</search for>

<replace>
					if ((${$uid.$lastposter}{'regdate'} && $messagedate > $registrationdate) || ${$uid.$lastposter}{'status'} eq "Administrator" || ${$uid.$lastposter}{'status'} eq "Global Moderator") {
						$lastposter = qq~$link{$lastposter}~;
					} else {
</replace>

<search for>
						if ((${$uid.$sblastposter}{'regdate'} && $sbmessagedate > $registrationdate) || ${$uid.$sblastposter}{'status'} eq "Administrator" || ${$uid.$sblastposter}{'status'} eq "Global Moderator") {
							$sblastposter = qq~<a href="$scripturl?action=viewprofile;username=$sblastposter">${$uid.$sblastposter}{'realname'}</a>~;
						} else {
</search for>

<replace>
						if ((${$uid.$sblastposter}{'regdate'} && $sbmessagedate > $registrationdate) || ${$uid.$sblastposter}{'status'} eq "Administrator" || ${$uid.$sblastposter}{'status'} eq "Global Moderator") {
							$sblastposter = qq~$link{$sblastposter}~;
						} else {
</replace>

<search for>
	if ($showlatestmember) {
		&LoadUser($latestmember);
		$latestmemberlink = qq~$boardindex_txt{'201'} <a href="$scripturl?action=viewprofile;username=$useraccount{$latestmember}"><b>${$uid.$latestmember}{'realname'}</b></a>.<br />~;
		$boardindex_template =~ s/<yabb latestmember>/$latestmemberlink/g;
	} else {
</search for>

<replace>
	if ($showlatestmember) {
		&LoadUser($latestmember);
		$latestmemberlink = qq~$boardindex_txt{'201'}: $link{$latestmember}.<br />~;
		$boardindex_template =~ s/<yabb latestmember>/$latestmemberlink/g;
	} else {
</replace>

<edit file>
Sources/Display.pl
</edit file>

<search for>
		while ($_ = each(%moderators)) {
			if ($username eq $_) { $iammod = 1; }
			&FormatUserName($_);
			$showmods .= qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$_}">$moderators{$_}</a>, ~;
		}
</search for>

<replace>
		while ($_ = each(%moderators)) {
			if ($username eq $_) { $iammod = 1; }
			$moderators{$_} = qq~$link{$_}~;
			$showmods .= qq~$moderators{$_}, ~;
		}
</replace>

<search for>
					$mlmb = ${$uid.$mlmb}{'realname'} || $mlmb || $display_txt{'470'};
</search for>

<replace>
					$mlmb = qq~$link{$mlmb}~ || $mlmb || $display_txt{'470'};
</replace>

<search for>
				$mlmb = ${$uid.$mlmb}{'realname'} || $mlmb || $display_txt{'470'};
</search for>

<replace>
				$mlmb = qq~$link{$mlmb}~ || $mlmb || $display_txt{'470'};
</replace>

<edit file>
Sources/MessageIndex.pl
</edit file>

<search for>
			if ($username eq $_) { $iammod = 1; }
			&FormatUserName($_);
			$showmods .= qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$_}">$moderators{$_}</a>, ~;
		}
</search for>

<replace>
			if ($username eq $_) { $iammod = 1; }
			$moderators{$_} = qq~$link{$_}~;
			$showmods .= qq~$moderators{$_}, ~;
		}
</replace>

<search for>
			if ((${$uid.$musername}{'regdate'} && $threadstartdate > $registrationdate) || ${$uid.$musername}{'status'} eq "Administrator" || ${$uid.$musername}{'status'} eq "Global Moderator") {
				$mname = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}">$ {$uid.$musername}{'realname'}</a>~;
			} else {
</search for>

<replace>
			if ((${$uid.$musername}{'regdate'} && $threadstartdate > $registrationdate) || ${$uid.$musername}{'status'} eq "Administrator" || ${$uid.$musername}{'status'} eq "Global Moderator") {
				$mname = qq~$link{$musername}~;
			} else {
</replace>

<search for>
			if ((${$uid.$lastposter}{'regdate'} && $messagedate > $registrationdate) || ${$uid.$lastposter}{'position'} eq "Administrator" || ${$uid.$lastposter}{'position'} eq "Global Moderator") { $lastposter = qq~<a href="$scripturl?action=viewprofile;username=$lastposter">${$uid.$lastposter}{'realname'}</a>~; }
</search for>

<replace>
			if ((${$uid.$lastposter}{'regdate'} && $messagedate > $registrationdate) || ${$uid.$lastposter}{'position'} eq "Administrator" || ${$uid.$lastposter}{'position'} eq "Global Moderator") { $lastposter = qq~$link{$lastposter}~; }
</replace>

<search for>
				while($tmpa = each(%moderators)) {
					&FormatUserName($tmpa);
					$showsbmods .= qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$tmpa}">$moderators{$tmpa}</a>, ~;
				}
</search for>

<replace>
				while($tmpa = each(%moderators)) {
					$showsbmods .= qq~$link{$tmpa}, ~;
				}
</replace>

<search for>
						if((${$uid.$lastposter}{'regdate'} && $messagedate > $registrationdate) || ${$uid.$lastposter}{'status'} eq "Administrator" || ${$uid.$lastposter}{'status'} eq "Global Moderator") { $lastposter = qq~<a href="$scripturl?action=viewprofile;username=$lastposter">${$uid.$lastposter}{'realname'}</a>~; }
</search for>

<replace>
						if((${$uid.$lastposter}{'regdate'} && $messagedate > $registrationdate) || ${$uid.$lastposter}{'status'} eq "Administrator" || ${$uid.$lastposter}{'status'} eq "Global Moderator") { 
						     $lastposter = qq~$link{$lastposter}~;
						}
</replace>

<search for>
						if ((${$uid.$sblastposter}{'regdate'} && $sbmessagedate > $registrationdate) || ${$uid.$sblastposter}{'status'} eq "Administrator" || ${$uid.$sblastposter}{'status'} eq "Global Moderator") {
							$sblastposter = qq~<a href="$scripturl?action=viewprofile;username=$sblastposter">${$uid.$sblastposter}{'realname'}</a>~;
						} else {
</search for>

<replace>
						if ((${$uid.$sblastposter}{'regdate'} && $sbmessagedate > $registrationdate) || ${$uid.$sblastposter}{'status'} eq "Administrator" || ${$uid.$sblastposter}{'status'} eq "Global Moderator") {
							$sblastposter = qq~$link{$sblastposter}~;
						} else {
</replace>

<edit file>
Sources/Notify.pl
</edit file>

<search for>
				$username_link = qq~<a href="$scripturl?action=viewprofile;username=$useraccount{$musername}">${$uid.$musername}{'realname'}</a>~;
</search for>

<replace>
				$username_link = qq~$link{$musername}~;
</replace>

<edit file>
Sources/Poll.pl
</edit file>

<search for>
		$displaydate = qq~<span class="small">&#171; $polltxt{'45a'}: <a href="$scripturl?action=viewprofile;username=$poll_modname">${$uid.$poll_modname}{'realname'}</a> $polltxt{'46'}: $poll_mod &#187;</span>~;
</search for>

<replace>
		$displaydate = qq~<span class="small">&#171; $polltxt{'45a'}: $link{$poll_modname} $polltxt{'46'}: $poll_mod &#187;</span>~;
</replace>

<search for>
			$displaydate = qq~<span class="small">&#171; $polltxt{'45'}: <a href="$scripturl?action=viewprofile;username=$poll_uname">${$uid.$poll_uname}{'realname'}</a> $polltxt{'46'}: $poll_date &#187;</span>~;
</search for>

<replace>
			$displaydate = qq~<span class="small">&#171; $polltxt{'45'}: $link{$poll_uname} $polltxt{'46'}: $poll_date &#187;</span>~;
</replace>

<search for>
			$voters_name = qq~<a href="$scripturl?action=viewprofile;username=$voters_name">${$uid.$voters_name}{'realname'}</a>~;
</search for>

<replace>
			$voters_name = qq~$link{$voters_name}~;
</replace>

<search for>
		$displaydate = qq~<span class="small">&#171; $polltxt{'45a'}: <a href="$scripturl?action=viewprofile;username=$poll_modname">${$uid.$poll_modname}{'realname'}</a> $polltxt{'46'}: $poll_mod &#187;</span>~;
</search for>

<replace>
		$displaydate = qq~<span class="small">&#171; $polltxt{'45a'}: $link{$poll_modname} $polltxt{'46'}: $poll_mod &#187;</span>~;
</replace>

<search for>
			$displaydate = qq~<span class="small">&#171; $polltxt{'45'}: <a href="$scripturl?action=viewprofile;username=$poll_uname">${$uid.$poll_uname}{'realname'}</a> $polltxt{'46'}: $poll_date &#187;</span>~;
</search for>

<replace>
			$displaydate = qq~<span class="small">&#171; $polltxt{'45'}: $link{$poll_uname} $polltxt{'46'}: $poll_date &#187;</span>~;
</replace>

<edit file>
Sources/Post.pl
</edit file>

<search for>
				$displaynamelink = qq~<a href="$scripturl?action=viewprofile;username=$tempname">${$uid.$tempname}{'realname'}</a>~;
</search for>

<replace>
				$displaynamelink = qq~$link{$tempname}~;
</replace>

<edit file>
Sources/Recent.pl
</edit file>

<search for>
		if ($enable_notification) { $notify = qq~$menusep<a href="$scripturl?board=$board;action=notify;thread=$tnum/$startnum">$img{'notify'}</a>~; }
		$mdate = &timeformat($mdate);
</search for>

<add after>
		$tname = qq~$link{$tusername}~;
		$mname = qq~$link{$musername}~;
</add after>

<search for>
		if ($pboard{"$board"} ne "") {
			@pboards = split(/\|/, $pboard{"$board"});
			foreach $pbd (@pboards) {
				($pbdname, $boardperms, $boardview) = split(/\|/, $board{"$pbd"});
				$parents .= qq~$pbdname / ~;
			}
		}

		$message = &Censor($message);
		$msub    = &Censor($msub);
		&wrap;
		if ($enable_ubbc) {
			$ns = $mns;
			if (!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; }
			&DoUBBC;
		}
		&wrap2;
		&ToChars($msub);
		&ToChars($message);
		&ToChars($boardname{$board});
		$msub =~ s/\A\[m\]/$maintxt{'758'}/;

		if ($enable_notification) { $notify = qq~$menusep<a href="$scripturl?board=$board;action=notify;thread=$tnum/$startnum">$img{'notify'}</a>~; }
		$mdate = &timeformat($mdate);
</search for>

<add after>
		$tname = qq~$link{$tusername}~;
		$mname = qq~$link{$musername}~;
</add after>

<edit file>
Sources/Search.pl
</edit file>

<search for>
		$msub =~ s/\A\[m\]/$maintxt{'758'}/;
</search for>

<add after>
		$tname = qq~$link{$tusername}~;
		$mname = qq~$link{$musername}~;
</add after>