##########################################################
#	RateIT.pl v1.7																													#
#	Original mod version Ratings SP1.3 v 4.5 by: Carsten. BIG THANKS!								#
#	Change and expand futures for YaBB2 by: Boris Tjuvanov (MF-B)								#
#																																			#
##########################################################

LoadLanguage("RateIT");
require "$vardir/RatingConf.txt";

if (($en_ratingsmenu == 0 || $en_ratingsmenu == 1 ) && $iamguest) { &fatal_error("$ratetxt{'128'}"); }

	if(-e ("$vardir/ratelist.txt")) {
		fopen(FILE, "$vardir/ratelist.txt");
		@ratelist = <FILE>;
		$ratecount = @ratelist;
		fclose(FILE);
		chomp(@ratelist);

		(undef, undef, undef, $gen_descrip, undef, undef, undef, $ssi_title, $ssi_bar, $ssi_text, undef, undef, undef, undef) = split(/\|/, $ratelist[0]);

		fopen(FILE, ">$vardir/rateitlist.txt", 1);
		print FILE "$gen_descrip|$ssi_title|$ssi_bar|$ssi_text\n";
		for($i=1; $i<$ratecount; $i++) {
			print FILE "$ratelist[$i]|0\n";
		}
		fclose(FILE);
		unlink("$vardir/ratelist.txt");
	}

	if(!-e ("$vardir/rateitlist.txt")) {
		fopen(FILE, ">$vardir/rateitlist.txt", 1);
		print FILE "|1|1|1\n";
		fclose(FILE);
	}

	@ratelist = ();
	@tmpratenames = ();
	@tmprateuser = ();
	@rtstate = ();

	fopen(FILE, "$vardir/rateitlist.txt");
	@ratelist = <FILE>;
	$ratecount = @ratelist;
	@ratenames = @ratelist;
	fclose(FILE);
	chomp(@ratenames);	
	
	for($i=1; $i<$ratecount; $i++) {
		$tmpratenames[$i] = "";
		$tmprateuser[$i] = "";
		($tmpratenames[$i], $tmprateuser[$i], $rtcatb[$i], $rtstate[$i])  = split(/\|/, $ratenames[$i]);
	}

	my($cssi_title, $cssi_bar, $cssi_text);
	($gen_descrip,$ssi_title, $ssi_bar, $ssi_text) = split(/\|/, $ratenames[0]);
	if($ssi_title) { $cssi_title = 'checked="checked"' }
	if($ssi_bar) { $cssi_bar = 'checked="checked"' }
	if($ssi_text) { $cssi_text = 'checked="checked"' }

	if($INFO{'editmode'} eq "") { $INFO{'editmode'} = 'new' }
	if(!$RatesPerPage) { $RatesPerPage = 10 }
	if(!$chars_comment) { $chars_comment = 200 }
	if(!$sort_ratesett) { $sort_ratesett = 1 }

	if($action eq "ratesettsort") { $sort_rate = $FORM{'sort'} }
	elsif($action eq "rateshowpg") { $sort_rate = $INFO{'rtcal'} }
	else { $sort_rate = $sort_ratesett }
	if($sort_rate == 1) { $ssrt1 = 'selected="selected"' } 
	elsif($sort_rate == 2) { $ssrt2 = 'selected="selected"' } 
	elsif($sort_rate == 3) { $ssrt3 = 'selected="selected"' }
	elsif($sort_rate == 4) { $ssrt4 = 'selected="selected"' } 
	elsif($sort_rate == 5) { $ssrt5 = 'selected="selected"' } 
	elsif($sort_rate == 6) { $ssrt6 = 'selected="selected"' } 
	else { $ssrt1 = 'selected="selected"'; $sort_rate = 1 }
	$ratecal = $sort_rate;
	
	unless ($grp_allow eq "" && $iamguest) {
		@grp_allow = split(/\, /, $grp_allow);
			foreach $grp_allow2 (@grp_allow) {
				if ($grp_allow2 eq $memberunfo{$username}) { $memgrprating = 1; last; }
			}
	} else {
		$memgrprating = 0;
	}

	my (undef, $cntrateboard, $cntbrateenable, $cntautoapplyrate, $cntviewrateindex, $cntratestar, $cntrategraph, $cntboardratelst);
	fopen(RATECONTROL, "+<$boardsdir/rate.cntr");
	seek RATECONTROL, 0, 0;
	my @boardratecontrols = <RATECONTROL>;
	fclose(RATECONTROL);
	foreach my $boardrateline (@boardratecontrols) {
		$boardrateline =~ s/[\r\n]//g;
		chomp $boardrateline;
		(undef, $cntrateboard, $cntbrateenable, $cntautoapplyrate, $cntviewrateindex, $cntratestar, $cntrategraph, $cntboardratelst) = split(/\|/, $boardrateline);
		${$uid.$cntrateboard}{'brate_enable'} = $cntbrateenable;
		${$uid.$cntrateboard}{'apply_arate'} = $cntautoapplyrate;
		${$uid.$cntrateboard}{'view_arate'} = $cntviewrateindex;
		${$uid.$cntrateboard}{'view_ratestar'} = $cntratestar;
		${$uid.$cntrateboard}{'view_rategraph'} = $cntrategraph;
		${$uid.$cntrateboard}{'view_bratelst'} = $cntboardratelst;
	}

	
	
sub Rate {

$yymain .= qq~
<div class="navbarcontainer">
<table cellpadding="4" cellspacing="0" border="0" width="100%" class="">
<tr>
<td align="left"><span class="nav"><b><a href="$scripturl">$mbname</a> &rsaquo; $ratetxt{'02b'}</b></span></td>
</tr>
</table>
</div>
~;

if($ratecount > 1) {

	$highclick = 0;
	$linkcount = 0;

	$invclick = 999999;

	$rateitemcount = $ratecount - 1;
	$x = 0;
	$fircat= "";
	$catcount = 0;

	for($i=1; $i<$ratecount; $i++) {
		$rateaccess[$i] = 1;
		$ratenam = $tmpratenames[$i];
		fopen(RATEFILE,"$RatesDir/$ratenam.rate");
		@rater = <RATEFILE>;
		fclose(RATEFILE);
		chomp(@rater);
		
		($ratecatchk[$i], $ratenmchk[$i]) = split(/\|/, $rater[0]);
		(undef, undef, $rtstate[$i]) = split(/\|/, $rater[1]);

foreach $catid (@categoryorder) {
	$boardlist = $cat{$catid};
	(@bdlist) = split(/\,/, $boardlist);
	foreach $curboard (@bdlist) {
		my ($boardname, $boardperms, $boardview) = split(/\|/, $board{"$curboard"});
		if ($ratecatchk[$i] eq $curboard){
			my $access = &AccessCheck($curboard, '', $boardperms);
			if (!$iamadmin && $access ne "granted" || (!$iamadmin && !$iamgmod && ($curboard eq $annboard ||$curboard eq $binboard)) || !${$uid.$curboard}{'view_bratelst'}) {
				$rateaccess[$i] = 0; next; 
			}
		}
	}
}

if ($rtstate[$i] =~ /h/i && !$iamadmin && !$iamgmod) { $rateaccess[$i] = 0; }
if ($iamadmin) { $rateaccess[$i] = 1; }
if ($rateaccess[$i] == 0) { --$rateitemcount; next; }
		
		(undef, $ratenclick) = split(/\|/, $rater[3]);
		if($ratenclick > $highclick) { $highclick = $ratenclick }
		if($rater[4] ne "") { $linkcount++ }
		if($sort_rate == 1) {
			$ratesrt1 = $ratenmchk[$i];
			$ratesrt1 =~ s/ //gi;
			$ratesrt1 =~ s/\.//gi;
			$ratesrt1 =~ s/\-//gi;
			($ratercnt, undef) = split(/\|/, $rater[3]);
			$ratercnt = $ratercnt * 100;
			$ratesrt2 = 2000 - $ratercnt;
			($ratesrt3, undef, undef) = split(/\|/, $rater[1]);
			$ratesrt3 =~ s/ //gi;
			$ratesrt3 =~ s/\.//gi;
			$ratesrt3 =~ s/\-//gi;
		}
		elsif($sort_rate == 2) {
			$ratesrt1 = $ratenmchk[$i];
			$ratesrt1 =~ s/ //gi;
			$ratesrt1 =~ s/\.//gi;
			$ratesrt1 =~ s/\-//gi;
			($ratesrt2, undef, undef) = split(/\|/, $rater[1]);
			$ratesrt2 =~ s/ //gi;
			$ratesrt2 =~ s/\.//gi;
			$ratesrt2 =~ s/\-//gi;
			$ratesrt3 = "";
		}
		elsif($sort_rate == 3) {
			$ratesrt1 = $ratenmchk[$i];
			$ratesrt1 =~ s/ //gi;
			$ratesrt1 =~ s/\.//gi;
			$ratesrt1 =~ s/\-//gi;
			(undef, $rclick) = split(/\|/, $rater[3]);
			$ratesrt2 = $invclick - $rclick;
			($ratesrt3, undef, undef) = split(/\|/, $rater[1]);
			$ratesrt3 =~ s/ //gi;
			$ratesrt3 =~ s/\.//gi;
			$ratesrt3 =~ s/\-//gi;
		}
		elsif($sort_rate == 4) {
			($ratercnt, undef) = split(/\|/, $rater[3]);
			$ratercnt = $ratercnt * 100;
			$ratesrt1 = 2000 - $ratercnt;
			($ratesrt2, undef, undef) = split(/\|/, $rater[1]);
			$ratesrt2 =~ s/ //gi;
			$ratesrt2 =~ s/\.//gi;
			$ratesrt2 =~ s/\-//gi;
			$ratesrt3 = "";
		}
		elsif($sort_rate == 5) {
			($ratercnt, undef) = split(/\|/, $rater[3]);
			$ratercnt = $ratercnt * 100;
			$ratesrt2 = 2000 - $ratercnt;
			($ratesrt1, undef, undef) = split(/\|/, $rater[1]);
			$ratesrt1 =~ s/ //gi;
			$ratesrt1 =~ s/\.//gi;
			$ratesrt1 =~ s/\-//gi;
			(undef, $rclick) = split(/\|/, $rater[3]);
			$ratesrt3 = $invclick - $rclick;
		}
		elsif($sort_rate == 6) {
			(undef, $rclick) = split(/\|/, $rater[3]);
			$ratesrt1 = $invclick - $rclick;
			($ratesrt2, undef, undef) = split(/\|/, $rater[1]);
			$ratesrt2 =~ s/ //gi;
			$ratesrt2 =~ s/\.//gi;
			$ratesrt2 =~ s/\-//gi;
			($ratercnt, undef) = split(/\|/, $rater[3]);
			$ratercnt = $ratercnt * 100;
			$ratesrt3 = 2000 - $ratercnt;
		}

		$templist[$x] .= qq($ratesrt1|$ratesrt2|$ratesrt3|$ratenames[$i]);
		$tempcatlist[$x] .= qq($ratenmchk[$i]|$ratenmchk[$i]);
		$x++;
	
		#} 
	
	}

	@SortAList = sort{lc($a) cmp lc($b)} (@templist);
	@SortAcatList = sort{lc($a) cmp lc($b)} (@tempcatlist);

	for($i=0; $i<$rateitemcount; $i++) {
		chomp(@SortAList);
		(undef, undef, undef, $SortList[$i], $SortUser[$i], $SortState[$i]) = split(/\|/, $SortAList[$i]);
	}
	chomp(@SortList);
	@ratename = @SortList;
	chomp(@SortUser);
	@rateuser = @SortUser;
	chomp(@SortState);
	@rstate = @SortState;

	for($i=0; $i<$rateitemcount; $i++) {
		chomp(@SortAcatList);
		($indxcat[$i], $SortcatList[$i]) = split(/\|/, $SortAcatList[$i]);
		$thiscat = $indxcat[$i];
		if($thiscat ne $fircat) {
			if($i < $RatesPerPage) { $catstart = 0; }
			else { $catstart = ( int($i / $RatesPerPage) ) * $RatesPerPage; }
			$catvalue = "";
			$catvalue .= qq($catstart|$i);
			$catjumpopt .= qq~<option value="$catvalue">$thiscat</option>\n~;
			$catopt .= qq~<option value="$thiscat">$thiscat</option>\n~;
			$fircat = $thiscat;
			$catcount++;
		}
	}

	if($INFO{'start'} eq "") { $start=0; } else { $start="$INFO{'start'}"; }
	$numshown=0;
	$numbegin = ($start + 1);
	$numend = ($start + $RatesPerPage);
	if($numend > $rateitemcount) { $numend = $rateitemcount; }
	$b = $start;

	$firstcat= "";

	$yymain .= qq~
<table border="0" width="100%" cellspacing="1" cellpadding="4" class="bordercolor" align="center">
	<tr>
		<td class="titlebg" colspan="5">
			<table border="0" width="100%" cellspacing="0" cellpadding="0" align="center">
				<tr>
				<td align="left">	<span class="text1"><img src="$modimgurl/RateIT/rate.gif" border="0" align="absmiddle" />$ratetxt{'02'}</span></td>
				<form method="post" action="$scripturl?action=ratejump" name="ratejump">
				<input type="hidden" name="rcal" value="$ratecal" />
				<td align="right">

					~;
	
	if($catcount > 1 && $sort_rate != 4 && $sort_rate != 5 && $sort_rate != 6) {
		$yymain .= qq~
					<span class="text1">$ratetxt{'19'}: </span>
						<select name="catjump" onChange="submit(); return true">
							<option value="">-------------------------</option>
							$catjumpopt
						</select>
		~;
	} else {
		$yymain .= qq~&nbsp;~;
	}
	
	$yymain .= qq~
				</td>
				</form>
				<form method="post" action="$scripturl?action=ratesettsort;editmode=new" name="ratesort">
				<td align="right">
	~;
	
	if($catcount > 1) {
	$yymain .= qq~
					<span class="text1">$ratetxt{'36'}: </span>
						<select name="sort" onChange="submit(); return true">
							<option value="1" $ssrt1>$ratetxt{'19'} - $ratetxt{'02'}</option>
							<option value="2" $ssrt2>$ratetxt{'19'} - $ratetxt{'08'}</option>
	~;
	
	if($linkcount > 0 && $highclick > 0) { $yymain .= qq~<option value="3" $ssrt3>$ratetxt{'19'} - $ratetxt{'17'}</option>~; }
	$yymain .= qq~
							<option value="4" $ssrt4>$ratetxt{'37'} - $ratetxt{'02'}</option>
							<option value="5" $ssrt5>$ratetxt{'37'} - $ratetxt{'08'}</option>
	~;
	
	if($linkcount > 0 && $highclick > 0) { $yymain .= qq~<option value="6" $ssrt6>$ratetxt{'37'} - $ratetxt{'17'}</option>~; }
	$yymain .= qq~
		</select>&nbsp;
	~;
	} else {
	$yymain .= qq~
						<span class="text1">$ratetxt{'36'}: </span>
						<select name="sort" onChange="submit(); return true">
							<option value="1" $ssrt1>$ratetxt{'02'}</option>
							<option value="2" $ssrt2>$ratetxt{'08'}</option>
	~;
	if($linkcount > 0 && $highclick > 0) { $yymain .= qq~<option value="3" $ssrt3>$ratetxt{'17'}</option>~; }
	$yymain .= qq~
						</select>
	~;
	}
	
	$yymain .= qq~
				</td>
				</form>
			</tr>
			</table>
		</td>
	</tr>
	~;

	if($gen_descrip ne "") {

	$pgen_descrip = $gen_descrip;
	$pgen_descrip =~ s~\&\&~<br />~g;
	$message = $pgen_descrip;
	&wrap;
	if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
	&wrap2;
	$pgen_descrip = $message;

	$yymain .= qq~
		<tr>
			<td class="windowbg" colspan="5" align="left"><span class="small">$pgen_descrip</span></td>
		</tr>
	~;
	}

	if($sort_rate == 4 || $sort_rate == 5 || $sort_rate == 6) {
		$yymain .= qq~
		</table>
		<br />
		<table border="0" width="100%" cellspacing="1" cellpadding="4" class="bordercolor" align="center">
		<tr>
		<td class="titlebg" align="left"><span class="small"><b>$ratetxt{'01'}</b></span></td>
		<td class="titlebg" align="center"><span class="small"><b>$ratetxt{'05'}</b></span></td>
		<td class="titlebg" align="center"><span class="small"><b>$ratetxt{'03'}</b></span></td>
		<td class="titlebg" align="center"><span class="small"><b>$ratetxt{'02'}</b></span></td>
		<td class="titlebg" align="center"><span class="small"><b>$ratetxt{'35'}</b></span></td>
		</tr>
		~;
	} else {
		$yymain .= qq~ 
		</table>
		<br />
		<table border="0" width="100%" cellspacing="1" cellpadding="4" class="bordercolor" align="center">
		~;
	}
	
	$rateopt = "";
	$useritemcount = 0;

	while(($numshown < $RatesPerPage)) {
		$numshown++;
		chomp(@ratename);
		$temprate = $ratename[$b];
		$ratename[$b] =~ s/ //gi;
		$ratename[$b] =~ s/\n//gi;
		$rate = $ratename[$b];
		$thisrateuser = $rateuser[$b];
		$thisrstate = $rstate[$b];
		$b++;

		@rateinfo = ();
		fopen(RATEFILEREAD,"$RatesDir/$rate.rate");
		@rateinfo = <RATEFILEREAD>;
		$lines = @rateinfo;
		fclose(RATEFILEREAD);
		chomp @rateinfo;
		
		&LoadUser($thisrateuser);

		$ratecatinfo = "";
		$ratenminfo = "";
		$rateinfoname = "";
		$rateinfodate = "";
		
		($ratecatinfo, $ratenminfo) = split(/\|/, $rateinfo[0]);
		($rateinfoname, $rateinfodate, $rateinfostat) = split(/\|/,$rateinfo[1]);

		if($temprate && $rateinfodate eq "") {
			$rateinfodate = $date;
			$num = $lines - 5;
			$z = 5;
			fopen(FILE, ">$RatesDir/$rate.rate", 1);
			print FILE "$ratecatinfo|$ratenminfo\n";
			print FILE "$rateinfoname|$rateinfodate|$rateinfostat\n";
			print FILE "$rateinfo[2]\n";
			print FILE "$rateinfo[3]\n";
			print FILE "$rateinfo[4]\n";
			for($i=0; $i<$num; $i++) {
				print FILE "$rateinfo[$z]\n";
				$z++;
			}
			fclose(FILE);
		}

		$startdate = &timeformat($rateinfodate);

		if ($iamadmin || $iamgmod || ($username eq $thisrateuser && $memgrprating)) {
			if($temprate) {
				$rateopt .= qq~<option value="$rate">$rateinfoname</option>\n~;
				$useritemcount++;
			}
		}

		@check = ();
		for($i=0; $i<11; $i++) { $check[$i] = "" }

		$thisuser = $username;
		$a_guest = 0;
		if($thisuser eq "Guest") { $thisuser = $user_ip; $a_guest = 1; }
		$totalrate = 0;
		$c = 0;
		$commentnum = 0;
		@thiscommenter = ();
		@thiscomment = ();
		@thisdate = ();
		$comment = "";
		$canrate = 1;
		$raters = $lines - 5;
		if($raters > 0) {
			for($i=5; $i < $lines; $i++) {
				$thiscommenter[$c] = "";
				$thiscomment[$c] = "";
				$thisdate[$c] = "";
				($thisrater, $thisrate, $thrater, $thiscomment[$c], $thisdate[$c]) = split(/\|/,$rateinfo[$i]);
				if($thisuser eq $thisrater) { 
					$thecomment = $thiscomment[$c];
					$intrate = int($thisrate);
					$check[$intrate] = "selected";
				}
				$totalrate = $totalrate + $thisrate;
				$delrater[$c] = $thisrater;
				if($thiscomment[$c] ne "") { 
					$commentnum++;
					if($thrater ne "Guest") {
						$thmember = $thrater;
						&LoadUser($thmember);
						$thiscommenter[$c] .= qq~$link{$thmember}~;
					} else {
						$thiscommenter[$c] = "Guest";
					}
				}

				$c++;
			}
			$therate = sprintf ("%.2f", ($totalrate/$raters));
		}
		else { $therate = "0.00" }
		$name = $rateinfoname;

		$descrip = $rateinfo[2];
		$descrip =~ s~\&\&~<br />~g;
		$message = $descrip;
		&wrap;
		if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
		&wrap2;

		$descrip = $message;

		($rating, $clicks) = split(/\|/,$rateinfo[3]);
		$link = $rateinfo[4];
		$barrate = $rating * 10;
		$ratebar = "";
		$ratebar1 = "";
		$ratebar2 = "";
		$ratebar3 = "";
		$barchart = int($barrate);
		$barchart1 = 100 - $barchart;
		
		if($stars_ratelist) {
			
			$ratebar .= qq~<div style="display: block; float: left; width: 40px;">$therate</div>~; 
			if($barchart < 10) { $ratebar .= qq~<div style="display: block;  float: right; width: 110px;"><a href="$scripturl?action=rateoverview;rateid=$rate"><img src="$modimgurl/RateIT/st00.gif" border="0" alt="" align="absmiddle" /></a></div>~; }
			elsif($barchart < 30) { $ratebar .= qq~<div style="display: block; float: right; width: 110px;"><a href="$scripturl?action=rateoverview;rateid=$rate"><img src="$modimgurl/RateIT/st01.gif" border="0" alt="" align="absmiddle" /></a></div>~; }
			elsif($barchart < 50) { $ratebar .= qq~<div style="display: block;  float: right; width: 110px;"><a href="$scripturl?action=rateoverview;rateid=$rate"><img src="$modimgurl/RateIT/st02.gif" border="0" alt="" align="absmiddle" /></a></div>~; }
			elsif($barchart < 70) { $ratebar .= qq~<div style="display: block;  float: right; width: 110px;"><a href="$scripturl?action=rateoverview;rateid=$rate"><img src="$modimgurl/RateIT/st03.gif" border="0" alt="" align="absmiddle" /></a></div>~; }
			elsif($barchart < 90) { $ratebar .= qq~<div style="display: block;  float: right; width: 110px;"><a href="$scripturl?action=rateoverview;rateid=$rate"><img src="$modimgurl/RateIT/st04.gif" border="0" alt="" align="absmiddle"/></a></div>~; }
			else { $ratebar .= qq~<div style="display: block;  float: right; width: 110px;"><a href="$scripturl?action=rateoverview;rateid=$rate"><img src="$modimgurl/RateIT/st05.gif" border="0" alt="" align="absmiddle" /></a></div>~; }
		
		} else {
			

			if ($barchart < 1) {
				$ratebar3 = "";
			} else {
				$ratebar3 = qq~<img src="$modimgurl/RateIT/ratebar.gif" width="$barchart" height="10" alt="" border="0" align="absmiddle" />~;
			}
			
			if ($barchart > 99) {
				$ratebar1 = "";
			} else {
				$ratebar1 = qq~<img src="$modimgurl/RateIT/ratebar1.gif" width="$barchart1" height="10" alt="" border="0" align="absmiddle" />~;
			}
			
			$ratebar .= qq~<div style="display: block; float: left; width: 40px;">$therate</div>~; 
			$ratebar .= qq~<div style="display: block;  float: right; width: 110px;"><a href="$scripturl?action=rateoverview;rateid=$rate">$ratebar3$ratebar1</a></div>~;
		
		}
		
		$ratebar2 = qq~$ratebar~;

		if($temprate) {

		if($sort_rate == 1 || $sort_rate == 2 || $sort_rate == 3) {
			$startcat = $ratenminfo;
			if($startcat ne $firstcat) {
				$firstcat = $startcat;
				$thecatnum = $b - 1;
				$thecatname = "";
				$thecatname .= qq(cat$thecatnum);
				#shadow
				$yymain .= qq~
				<tr>
					<td class="catbg" colspan="5"><img src="$imagesdir/thread.gif" alt="" align="absmiddle" /><a name="$thecatname"></a>&nbsp;$startcat</td>
				</tr>
				<tr>
					<td class="titlebg" align="left"><span class="small"><b>&nbsp;&nbsp;$ratetxt{'01'}</b></span></td>
					<td class="titlebg" align="center"><span class="small"><b>$ratetxt{'05'}</b></span></td>
					<td class="titlebg" align="center"><span class="small"><b>$ratetxt{'03'}</b></span></td>
					<td class="titlebg" align="center"><span class="small"><b>$ratetxt{'02'}</b></span></td>
					<td class="titlebg" align="center"><span class="small"><b>$ratetxt{'35'}</b></span></td>
				</tr>
				~;
			}
		}

		
			if ($opnrate_window) { $opnratew = 'target="_blank"' } 
			
			if($iamguest && !$guest_rate) { 
				$tmp_link = qq($name);
			} else { 
				$tmp_link = qq(<a href="$scripturl?action=rateclicks;rateid=$rate" $opnratew name="$rate">$name</a>);
			}

				if($allow_comment) { 
					$yymain .= qq~<td rowspan="2" class="windowbg" width="50%" align="left" valign="top">~; 
				} else { 
					$yymain .= qq~<td class="windowbg" width="50%" align="left" valign="top">~; 
				}

				if($link eq "") {
				$yymain .= qq~
					<div style="float: left;"><nobr><b><a name="$rate"></a>$name</b></nobr></div><br />
					<div style="float: left;" class="small">$descrip</div>
					</td>
				~;
				} else {
				$yymain .= qq~
					<div style="float: left;"><nobr><b>$tmp_link</b></nobr></div>
					<div style="float: right;" class="small"><nobr><i>$ratetxt{'17'}: $clicks</i></nobr></div><br />
					<div style="float: left;" class="small">$descrip</div>
					</td>
				~;
				}

			$yymain .= qq~
				<td class="windowbg2" align="center" valign="middle">$raters</td>
			~;

				if(!$iamguest || $guest_rate) {
					if($rateinfostat !~ /l/i) {
						$yymain .= qq~
						<td class="windowbg2" align="center" valign="middle">
						<form method="post" action="$scripturl?action=ratesett2" name="$rate">
						<input type="hidden" name="filename" value="$rate" />
						<input type="hidden" name="username" value="$username" />
						<input type="hidden" name="start" value="$start" />
						<input type="hidden" name="rcal" value="$ratecal" />
						<input type="hidden" name="ratetype" value="ratein" />
							<select name="rating" onChange="submit(); return true">
								<option value="0" $check[0]>---</option>
								<option value="10" $check[10]>10 $ratetxt{'48'}</option>
								<option value="9" $check[9]>9</option>
								<option value="8" $check[8]>8</option>
								<option value="7" $check[7]>7</option>
								<option value="6" $check[6]>6</option>
								<option value="5" $check[5]>5</option>
								<option value="4" $check[4]>4</option>
								<option value="3" $check[3]>3</option>
								<option value="2" $check[2]>2</option>
								<option value="1" $check[1]>1</option>
							</select>
						</form>
						</td>
					~;
					} else {
						$yymain .= qq~
						<td class="windowbg2" align="center" valign="middle">
							<img src="$modimgurl/RateIT/ratelock.gif" border="0" align="absmiddle" alt="$txt{'456'}" />
						</td>
						~;
					}
				} else {
				$yymain .= qq~
				<td class="windowbg2" align="center" valign="middle">
					<img src="$imagesdir/ban.gif" border="0" align="absmiddle" alt="$ratetxt{'21'}" />
				</td>
				~;
				}
			$yymain .= qq~
				<td class="windowbg2" width="160" align="center">$ratebar2</td>
				~;
				
			if($allow_comment) {
				$yymain .= qq~<td rowspan="2" class="windowbg"  align="center">~;
			} else {
				$yymain .= qq~<td class="windowbg"  align="center">~;
			}

			$yymain .= qq~
				<div align="center" class="small">$startdate<br /><nobr>$link{$thisrateuser}</nobr></div>
				</td>
			</tr>
			~;

			if($allow_comment) {
				$yymain .= qq~
				<tr>
					<td class="windowbg" colspan="3">
					<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
					<div style="display: block; top: 0px; left: 0px; height: 90px; width: 95%; padding-left: 7px; padding-top: 0px; padding-right: 7px; overflow: auto;" class="windowbg2">
					~;
						
							if((!$iamguest || $guest_rate) && $INFO{'commentmode'} eq $rate) {
								$thecomment =~ s~\&\&~\n~g;
								$yymain .= qq~
								<form action="$scripturl?action=ratecomment" method="post" name="postmodify">
								<span class="small"><b>$ratetxt{'62'}:</b><br /></span>
								<table border="0" cellspacing="0" cellpadding="2" align="center">
								<tr>
									<td valign="middle">
									<textarea style="width: 235px" name="message" cols="40" rows="4" wrap="soft" onclick="javascript:storeCaret(this);" onkeyup="javascript:storeCaret(this);" onchange="javascript:storeCaret(this);">$thecomment</textarea>
									</td>
									<td valign="middle">
									<input type="hidden" name="filename" value="$rate" />
									<input type="hidden" name="username" value="$username" />
									<input type="hidden" name="start" value="$start" />
									<input type="hidden" name="rcal" value="$ratecal" />
									<input value="$chars_comment" name="msgCL" style="width: 40px;" disabled="disabled" /><br />
									<input type="submit" value="$ratetxt{'64'}" style="width: 100px;" />
									<script language="JavaScript1.2" type="text/javascript">
									<!--
										var supportsKeys = false
										function tick() {
										calcCharLeft(document.forms[0])
										if (!supportsKeys) timerID = setTimeout("tick()",$chars_comment)
										}

										function calcCharLeft(sig) {
										clipped = false
										maxLength = $chars_comment
										if (document.postmodify.message.value.length > maxLength) {
											document.postmodify.message.value = document.postmodify.message.value.substring(0,maxLength)
											charleft = 0
											clipped = true
									  	} 
										else {
											charleft = maxLength - document.postmodify.message.value.length
									  	}
										document.postmodify.msgCL.value = charleft
										return clipped
										}
										tick();
									//-->
									</script>
									</td>
								</tr>
								</table>
								</form>
								~;
							}

					$yymain .= qq~<br /><br /><p align="center" class="small"><b>$ratetxt{'61'}:</b> $commentnum</p><br /><br /><br />~;
						
						for($i=0; $i<$raters; $i++) {
							$comment = $thiscomment[$i];
							if($comment ne "") {
								&LoadCensorList;
								$comment   = &Censor($comment);
								$pthisdate = &timeformat($thisdate[$i]); 
								$comment =~ s~\&\&~<br />~g;
								if($ubbc_comment) {
									$message = $comment;
									$char_160 = chr(160);
									$message =~ s~\[img\][\s*\t*\n*(&nbsp;)*($char_160)*]*(http\:\/\/)*(.+?)[\s*\t*\n*(&nbsp;)*($char_160)*]*\[/img\]~\[url=http\:\/\/$2\]\[img\]$imagesdir/img2.gif\[\/img\]\[\/url\]~isg;
									&wrap;
									if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
									&wrap2;
									$comment = $message;
								}
								$yymain .= qq~
								<span class="small"><b>$thiscommenter[$i]</b> - $pthisdate<br />
								$comment
								</span><br />
								~;
								if ($iamadmin || $iamgmod) {
								$yymain .= qq~
									<a href="$scripturl?action=ratedelcomment;rater=$delrater[$i];name=$rate;rcal=$ratecal;start=$start"><img src="$imagesdir/im_delete.gif" border="0" align="absmiddle" alt="$ratetxt{'12'}" /></a>
									<br />
								~;
								}
								$yymain .= qq~
								<br />
								~;
							}

						}
						
					$yymain .= qq~
					</div>
					</td>
				</tr>
				~;
			}
		}
	}

	$postdisplaynum = 8;
	$max = $rateitemcount;
	$start = $INFO{'start'} || 0;
	$start = ( int( $start / $RatesPerPage ) ) * $RatesPerPage;
	$tmpa = 1;
	$tmpx = int( $max / $RatesPerPage );
	if ($start >= (($postdisplaynum-1) * $RatesPerPage)) { $startpage = $start - (($postdisplaynum-1) * $RatesPerPage); $tmpa = int( $startpage /$RatesPerPage ) + 1; }
	if ($max >= $start + ($postdisplaynum * $RatesPerPage)) { $endpage = $start + ($postdisplaynum * $RatesPerPage); } else { $endpage = $max }
	if ($startpage > 0) { $pageindex = qq~<a href="$scripturl?action=rateshowpg;rtcal=$ratecal;editmode=new;start=0">1</a>&nbsp;...&nbsp;~; }
	if ($startpage == $RatesPerPage) { $pageindex = qq~<a href="$scripturl?action=rateshowpg;rtcal=$ratecal;editmode=new;start=0">1</a>&nbsp;~;}
	for( $counter = $startpage; $counter < $endpage; $counter += $RatesPerPage ) {
		$pageindex .= $start == $counter ? qq~<b>$tmpa</b>&nbsp;~ : qq~<a href="$scripturl?action=rateshowpg;rtcal=$ratecal;editmode=new;start=$counter">$tmpa</a>&nbsp;~;
		$tmpa++;
	}
	$tmpx = $max - $RatesPerPage;
	$outerpn = int($tmpx / $RatesPerPage) + 0;
	$lastpn = int($rateitemcount / $RatesPerPage) + 1;
	$lastptn = ($lastpn - 1) * $RatesPerPage;
	if ($endpage < $max - ($RatesPerPage) ) {$pageindexadd = qq~&nbsp;...&nbsp;~;}
	if ($endpage != $max) {$pageindexadd .= qq~&nbsp;<a href="$scripturl?action=rateshowpg;rtcal=$ratecal;editmode=new;start=$lastptn">$lastpn</a>~;}
	$pageindex .= $pageindexadd;

$yymain .= qq~
</table>
<br />
<table cellpadding="4" cellspacing="0" border="0" width="100%" class="">
<tr><td class="catbg"><b>&nbsp;$ratetxt{'139'}:</b> $pageindex</td></tr>
</table>
~;


} else {
$yymain .= qq~
</table>
<br />
<table cellpadding="4" cellspacing="0" border="0" width="100%" class="">
<tr><td class="titlebg"><b><img src="$modimgurl/RateIT/rate.gif" border="0" align="absmiddle" />$ratetxt{'02'}</b></td></tr>
<tr>	<td class="windowbg" colspan="5" align="center"><b>$ratetxt{'25'}</b></td></tr>
</table>
~;
}

if ($iamadmin || $iamgmod || $memgrprating) {

$yymain .= qq~
<br /><br />
<table border="0" width="100%" cellspacing="1" cellpadding="4" class="bordercolor" align="center">
~;

my($editid, $editcatid, $editcat, $editname, $editdescr, $editlink, $extlink, $yablink, $ssilink, $topcode);
$thelinkitem = $INFO{'linkitem'};

if($INFO{'editmode'} eq "new") {
	$edittest = 0;
} elsif($INFO{'editmode'} eq "exlink") {
	@rateinfo = ();
	fopen(RATEFILEREAD,"$RatesDir/$INFO{'linkitem'}.rate");
	@rateinfo = <RATEFILEREAD>;
	@lines = @rateinfo;
	fclose(RATEFILEREAD);
	chomp @lines;
	($theiname, $theidate) = split(/\|/,$lines[1]);
	$imgdir = substr($imagesdir,7);
	$edittest = 0;
	$shtitle = $INFO{'sititle'};
	$shbar = $INFO{'sibar'};
	$shtext = $INFO{'sitext'};
	$linkname = $theiname;
	$extlink .= qq~\<a href=$scripturl?action=ratepglink;editmode=new;itemlink=$thelinkitem target=\_blank\>\<img src=$imagesdir\/rate.gif border=0 align=absmiddle\>\<b\> $ratetxt{'27'}\<\/b\>\<\/a\>~;
	$yablink .= qq~\[url=$scripturl?action=ratepglink;editmode=new;itemlink=$thelinkitem\]\[img\]$imgdir\/rate.gif\[\/img\]\[b\] $ratetxt{'27'}\[\/b\]\[\/url\]~;
	$ssilink .= qq~\<!--\#include virtual='$ssi_dir\/Ratessi.pl?rateid=$shtitle|$shbar|$shtext|$thelinkitem' --\>~;

$topcode .= qq~
<!---rate code start---place this where you want the rating to go--->
<nolayer>
<iframe src="$boardurl/Ratetoplist.pl?action=seltoprate;rateid=$thelinkitem" width="350" height="30" marginwidth="0" marginheight="0" hspace="0" vspace="0" frameborder="0" scrolling="no" bordercolor="#000000"></iframe><br />
</nolayer>
<table cellspacing="0" cellpadding="0" border="0" height="1" width="1">
<tr><td>
<ilayer id="ratings" visibility="hidden" height="30" width="350"></ilayer>
</td></tr>
</table>
<!---rate code end-->\n
<!---rate code start---place this just before the </body>!!! --->
<layer src="$boardurl/Ratetoplist.pl?action=seltoprate;rateid=$thelinkitem" visibility="hidden" onLoad="moveToAbsolute(ratings.pageX, ratings.pageY); ratings.clip.height=30; ratings.clip.width=350; visibility='show';"></layer>
<!---rate code end-->
~;
	&ToHTML($topcode);
} else {
	@rateinfo = ();
	fopen(RATEFILEREAD,"$RatesDir/$INFO{'editmode'}.rate");
	@rateinfo = <RATEFILEREAD>;
	@lines = @rateinfo;
	fclose(RATEFILEREAD);
	chomp @lines;
	($editcatid, $editcat) = split(/\|/,$lines[0]);
	($theiname, $theidate, $editstatus) = split(/\|/,$lines[1]);
	$editid = $INFO{'editmode'};
	$editname = $theiname;
	$editdescr = $lines[2];
	
	$editdescr =~ s/&amp;/&/g;
	$editdescr =~ s/&quot;/"/g;
	$editdescr =~ s/&lt;/</g;
	$editdescr =~ s/&gt;/>/g;
	$editdescr =~ s/\&\&/\n/g;
	$editlink = $lines[4];
	$edittest = 1;
}

			$yymain .= qq~
			<tr>
				<td class="titlebg">
					<b><span class="text1"><a name="edi"></a><img src="$modimgurl/RateIT/rate.gif" border="0" align="absmiddle" />$ratetxt{'23'}</span></b>
				</td>
			</tr>
			<tr>
			<td class="windowbg">
				<table width="100%" border="0" cellspacing="0" cellpadding="0" align="center">
				<tr>
				<td width="50%" align="center">
				<form method="post" action="$scripturl?action=ratesett;editmode=new#edi" name="rate">
				<table border="0" cellspacing="0" cellpadding="3" align="center">
					<tr>
						<td valign="top">
						<input type="hidden" name="ratetest" value="$edittest" />
						<input type="hidden" name="start" value="$start" />
						<input type="hidden" name="rateid" value="$editid" />
						<b>$ratetxt{'19'}</b>
						~;
						
						if($iamadmin || $iamgmod || $memgrprating) {
						$yymain .= qq~
							<br /><span class="small">$ratetxt{'20'}
						~;
						}
						
						$yymain .= qq~
						</span>
						</td><td>
						~;
						
						if($iamadmin || $iamgmod || $memgrprating) {
						$yymain .= qq~
							<input type="hidden" name="ratestatus" value="$editstatus" />
							<input type="hidden" name="ratecatid" value="$editcatid" />
							<input type="text" maxlength="50" name="ratecat" value="$editcat" size="50" /><br />
						~;
						} else {
						$yymain .= qq~
							<input type="hidden" name="ratestatus" value="$editstatus" />
							<input type="hidden" name="ratecatid" value="$editcatid" />
							<input type="hidden" name="ratecat" value="$editcat" />
						~;
						}
						
						$yymain .= qq~
						<select name="catedit"><option value="new">----------------------------------------------------------</option>$catopt</select><br /><br />
						</td>
					</tr><tr>
						<td><b>$ratetxt{'08'}</b></td>
						<td><input type="text" maxlength="50" name="ratename" value="$editname" size="50" /></td>
					</tr><tr>
						<td><b>$ratetxt{'09'}</b></td>
						<td><textarea name="descrip" rows="20" cols="50" style="height: 150px; visibility: visible;" wrap="virtual">$editdescr</textarea></td>
					</tr><tr>
						<td><b>$ratetxt{'15'}</b><span class="small">$ratetxt{'16'}</span></td>
						<td><input type="text" maxlength="300" name="link" value="$editlink" size="50" /></td>
					</tr><tr>
						<td>&nbsp;	</td>
						<td align="center"><input type="submit" value="$ratetxt{'10'}" style="width:150px;"  /></td>
					</tr>
				</table>
				</form>
				</td>
				<td width="50%" align="center">
				~;
				if($useritemcount > 0) {
				$yymain .= qq~
				<form method="post" action="$scripturl?action=rateshow2#edi" name="ratemark">
				<table border="0" cellspacing="0" cellpadding="3" align="center">
					<tr>
						<td height="100%" align="center" valign="middle">
						<input type="hidden" name="button" value="0" />
						<input type="hidden" name="start" value="$start" />
						<input type="hidden" name="ertcal" value="$ratecal" />
						<select size="$RatesPerPage" name="ratedit" style="width:300px;">$rateopt</select>
						</td>
					</tr>
					<tr>
						<td align="center">
						<input type="submit" value="$ratetxt{'11'}" style="width:300px;" onclick="javascript:window.document.ratemark.button.value = '1';" />
						</td>
					</tr>
					<tr>
						<td align="center">
						<input type="submit" value="$ratetxt{'12'}" style="width:148px;" onclick="javascript:window.document.ratemark.button.value = '2';" />
						<input type="submit" value="$ratetxt{'55'}" style="width:148px;" onclick="javascript:window.document.ratemark.button.value = '4';" />
						</td>
					</tr>
					~;
						if($iamadmin || $iamgmod || $memgrprating) {
						$yymain .= qq~
						<tr>
						<td align="center">
							<table width="200" border="0" cellspacing="0" cellpadding="0" align="center">
					  		<tr>
								<td align="left">$ratetxt{'53'}</td>
								<td align="left"><input type="checkbox" name="ssi_title" $cssi_title /></td>
					  		</tr>
					  		<tr>
								<td align="left">$ratetxt{'54'}</td>
								<td align="left"><input type="checkbox" name="ssi_bar" $cssi_bar /></td>
					  		</tr>
					  		<tr>
								<td align="left">$ratetxt{'58'}</td>
								<td align="left"><input type="checkbox" name="ssi_text" $cssi_text /></td>
					  		</tr>
							</table>
						</td>
						</tr>
						~;
						} else {
							$yymain .= qq~
								<input type="hidden" name="ssi_title" value="$ssi_title" />
								<input type="hidden" name="ssi_bar" value="$ssi_bar" />
								<input type="hidden" name="ssi_text" value="$ssi_text" />
							~;
						}
					$yymain .= qq~
					<tr>
						<td align="center">
						<input type="submit" value="$ratetxt{'26'}" style="width:300px;" onclick="javascript:window.document.ratemark.button.value = '3';" />
						</td>
					</tr>
				</table>
				</form>
				~;
				} else { $yymain .= qq~&nbsp;~;	}
				$yymain .= qq~
				</td>
				</tr>
				</table>
			</td>
			</tr>
			~;
			if($extlink ne "") {
			$yymain .= qq~
			<tr>
				<td class="catbg"><b>&nbsp; $ratetxt{'47'} $linkname</b></td>
			</tr>
			<tr>
			<td class="windowbg">
			<table border="0" cellspacing="0" cellpadding="3" align="center">
			<tr>
				<form name="sellink0">
				<td><b>$ratetxt{'66'}</b><br /><span class="small">$ratetxt{'67'}</span></td>
				<td><textarea cols="79" rows="10" name="topcode">$topcode</textarea></td>
				<td><input type="button" value="$ratetxt{'28'}" onClick="this.form.topcode.select();this.form.topcode.focus();document.execCommand('Copy')" /></td>
				</form>
			</tr>
			~;
			if($iamadmin || $iamgmod || $memgrprating) {
			$yymain .= qq~
			<tr>
				<form name="sellink1">
				<td><b>$ratetxt{'29'}</b></td>
				<td><input stype="text" name="yablink" value="$yablink" size="80" /></td>
				<td><input type="button" value="$ratetxt{'28'}" onClick="this.form.yablink.select();this.form.yablink.focus();document.execCommand('Copy')" />	</td>
				</form>
			</tr>
			<tr>
				<form name="sellink2">
				<td><b>$ratetxt{'30'}</b></td>
				<td><input type="text" name="extlink" value="$extlink" size="80" /></td>
				<td><input type="button" value="$ratetxt{'28'}" onClick="this.form.extlink.select();this.form.extlink.focus();document.execCommand('Copy')" /></td>
				</form>
			</tr>
			<tr>
				<form name="sellink3">
				<td><b>$ratetxt{'40'}</b></td>
				<td><input type="text" name="ssilink" value="$ssilink" size="80" /></td>
				<td><input type="button" value="$ratetxt{'28'}" onClick="this.form.ssilink.select();this.form.ssilink.focus();document.execCommand('Copy')" /></td>
				</form>
			</tr>
			~;
			}
			$yymain .= qq~
			</table>
			</td>
			</tr>
			~;
			}
			$yymain .= qq~
</table>
~;
}

if($iamadmin || $iamgmod || $memgrprating) {

$egen_descrip = $gen_descrip;

$egen_descrip =~ s/&amp;/&/g;
$egen_descrip =~ s/&quot;/"/g;
$egen_descrip =~ s/&lt;/</g;
$egen_descrip =~ s/&gt;/>/g;
$egen_descrip =~ s/\&\&/\n/g;

$yymain .= qq~
<br />
<table border="0" width="100%" cellspacing="1" cellpadding="4" class="bordercolor" align="center">
	<tr>
		<td class="titlebg">
			<b><span class="text1"><img src="$modimgurl/RateIT/rate.gif" border="0" align="absmiddle" />$ratetxt{'39'}</span></b>
		</td>
	</tr>
	<tr>
		<td class="windowbg" align="center">
		<form method="post" action="$scripturl?action=ratepagesett;editmode=new" name="setpage">
		<table border="0" cellspacing="0" cellpadding="3" align="center">
			<tr><td valign="middle"><textarea name="egen_descrip" cols="70" rows="4" wrap="virtual">$egen_descrip</textarea></td></tr>
			<tr><td align="center"><input type="submit" value="$ratetxt{'10'}" style="width: 100px;" /></td></tr>
		</table>
		</form>
		</td>
	</tr>
</table>
~;
}

$yytitle = "$ratetxt{'02b'}";
&template;
exit;

}


sub PageSetting {
$FORM{'egen_descrip'} =~ s~\n~\&\&~g;
my($key, $value);
while( ($key,$value) = each(%FORM) ) {
	$value =~ s~\A\s+~~;
	$value =~ s~\s+\Z~~;
	$value =~ s~[\n\r]~~g;
	$settingrates{$key} = $value;
}

	$settingrates{'egen_descrip'} =~ s/</&lt;/g;
	$settingrates{'egen_descrip'} =~ s/</&gt;/g;

	$egen_descrip = $settingrates{'egen_descrip'} || "";

	fopen(FILE, "$vardir/rateitlist.txt");
	@ratelist = <FILE>;
	$ratenum = @ratelist;
	fclose(FILE);
	chomp @ratelist;

	my($gen_descrip, $ssi_title, $ssi_bar, $ssi_text);
	($gen_descrip, $ssi_title, $ssi_bar, $ssi_text) = split(/\|/, $ratelist[0]);
	$prssititle = $ssi_title;
	$prssibar = $ssi_bar;
	$prssitext = $ssi_text;

	$ratelist[0] = "";
	$ratelist[0] .= qq($egen_descrip|$prssititle|$prssibar|$prssitext);
	fopen(FILE, ">$vardir/rateitlist.txt", 1);
	print FILE "$ratelist[0]\n";
	for($i=1; $i<$ratenum; $i++) {
		chomp @ratelist;
		print FILE "$ratelist[$i]\n";
	}
	fclose(FILE);

	$yySetLocation = qq~$scripturl?action=rateshow;editmode=new~;
	&redirectexit;
}


sub AdminAddRate {
	$rateid = $INFO{'thread'};
	$ratename = $INFO{'ratename'};
	$ratestatus = $INFO{'ratestatus'};
	if (!$ratestatus) { $ratestatus = 0; }
	
		$ratename =~ s/&amp;/&/g;
		$ratename =~ s/&quot;/"/g;
		$ratename =~ s/&lt;/</g;
		$ratename =~ s/&gt;/>/g;
		&FromChars($ratename);
		$ratename =~ s/&/&amp;/;
		$ratename =~ s/"/&quot;/g;
		$ratename =~ s/</&lt;/g;
		$ratename =~ s/>/&gt;/g;
	
	$ratedescrip = "";
	$ratelink = qq~$scripturl?num=$rateid~;

	if(!-e ("$vardir/rateitlist.txt")) {
		fopen(FILE, ">$vardir/rateitlist.txt", 1);
		print FILE "|1|1|1\n";
		fclose(FILE);
	}

	fopen(FILE, "$vardir/rateitlist.txt");
	@ratelist = <FILE>;
	$listnum = @ratelist;
	fclose(FILE);

	$namestart = "";
	$namestart .= qq($ratename|$date|$ratestatus);

	fopen( FILE, ">$RatesDir/$rateid.rate", 1);
	print FILE "$INFO{'yabbcat'}|$INFO{'ratecat'}\n";
	print FILE "$namestart\n";
	print FILE "$ratedescrip\n";
	print FILE "0.00|0\n";
	print FILE "$ratelink\n";
	fclose(FILE);


	fopen(FILE, ">$vardir/rateitlist.txt", 1);
	foreach $currate (@ratelist) {
		chomp $currate;
		print FILE "$currate\n";
	}
	print FILE "$rateid|$username|$INFO{'yabbcat'}|$ratestatus\n";
	fclose(FILE);

	$yySetLocation = qq~$scripturl?num=$rateid~;
	&redirectexit;

}

sub AdminRemRate {
	$edirate = $INFO{'thread'};
	fopen(FILE, "$vardir/rateitlist.txt");
	@ratelist = <FILE>;
	fclose(FILE);

	fopen(FILE, ">$vardir/rateitlist.txt", 1);
	foreach $currate (@ratelist) {
		chomp $currate;
		($thiscurrate, undef, undef, undef) = split(/\|/, $currate);
		if($thiscurrate ne $edirate) { print FILE "$currate\n"; }
	}
	fclose(FILE);

	unlink("$RatesDir/$edirate.rate");

	$yySetLocation = qq~$scripturl?num=$edirate~;
	&redirectexit;
}


sub DelComment {
	fopen(FILE, "$RatesDir/$INFO{'name'}.rate");
	@ratesettings=<FILE>;
	$ratenum = @ratesettings;
	fclose(FILE);
	chomp @ratesettings;

	fopen( FILE, ">$RatesDir/$INFO{'name'}.rate", 1);
	print FILE "$ratesettings[0]\n";
	print FILE "$ratesettings[1]\n";
	print FILE "$ratesettings[2]\n";
	print FILE "$ratesettings[3]\n";
	print FILE "$ratesettings[4]\n";
	for($i=5; $i<$ratenum; $i++) {
		($therater, $oldrate, $trater, $tcomment, $tdate) = split(/\|/,$ratesettings[$i]);
		if($therater ne $INFO{'rater'}) { 
			print FILE "$ratesettings[$i]\n";
		}
		else {
			print FILE "$therater|$oldrate|$trater||$tdate\n";
		}
	}
	fclose(FILE);

$yySetLocation = qq~$scripturl?action=rateshowpg;rtcal=$INFO{'rcal'};editmode=new;commentmode=norate;start=$INFO{'start'}#$INFO{'name'}~;
&redirectexit;
}


sub ShowRate2 {
my($key, $value);
while( ($key,$value) = each(%FORM) ) {
	$value =~ s~\A\s+~~;
	$value =~ s~\s+\Z~~;
	$value =~ s~[\n\r]~~g;
	$ratings{$key} = $value;
}
$edirate = $ratings{'ratedit'};
chomp $edirate;
if($edirate eq "") { &fatal_error("$ratetxt{'31'}"); }

if($ratings{'button'} eq "1") {
	$yySetLocation = qq~$scripturl?action=rateshowpg;rtcal=$ratings{'ertcal'};editmode=$edirate;start=$ratings{'start'}~;
	&redirectexit;
} elsif($ratings{'button'} eq "2") {
	fopen(FILE, "$vardir/rateitlist.txt");
	@ratelist = <FILE>;
	fclose(FILE);

	fopen(FILE, ">$vardir/rateitlist.txt", 1);
	foreach $currate (@ratelist) {
		chomp $currate;
		($thiscurrate, undef, undef, undef) = split(/\|/, $currate);
		if($thiscurrate ne $edirate) { print FILE "$currate\n"; }
	}
	fclose(FILE);

	unlink("$RatesDir/$edirate.rate");

	$yySetLocation = qq~$scripturl?action=rateshowpg;rtcal=$ratings{'ertcal'};editmode=new;start=$ratings{'start'}~;
	&redirectexit;
} elsif($ratings{'button'} eq "3") {
	my @onoff = qw/
		ssi_title ssi_bar ssi_text/;

	my $fi;
	map { $fi = lc $_; ${$_} = $FORM{$fi} eq 'on' ? 1 : 0; } @onoff;

	fopen(FILE, "$vardir/rateitlist.txt");
	@ratelist = <FILE>;
	$ratenum = @ratelist;
	fclose(FILE);
	chomp @ratelist;
	my($egen_descrip, $prssititle, $prssibar, $prssitext);
	($egen_descrip, $prssititle, $prssibar, $prssitext) = split(/\|/, $ratelist[0]);

	$prssititle = $ssi_title;
	$prssibar = $ssi_bar;
	$prssitext = $ssi_text;
	$ratelist[0] = "";
	$ratelist[0] .= qq($egen_descrip|$prssititle|$prssibar|$prssitext);
	fopen(FILE, ">$vardir/rateitlist.txt", 1);
	print FILE "$ratelist[0]\n";
	for($i=1; $i<$ratenum; $i++) {
		chomp @ratelist;
		print FILE "$ratelist[$i]\n";
	}
	fclose(FILE);

	$yySetLocation = qq~$scripturl?action=rateshowpg;rtcal=$ratings{'ertcal'};editmode=exlink;sititle=$ssi_title;sibar=$ssi_bar;sitext=$ssi_text;linkitem=$edirate;start=$ratings{'start'}~;
	&redirectexit;
} elsif($ratings{'button'} eq "4") {
	fopen(FILE, "$RatesDir/$edirate.rate");
	@ratesettings=<FILE>;
	$ratenum = @ratesettings;
	fclose(FILE);
	chomp @ratesettings;

	fopen( FILE, ">$RatesDir/$edirate.rate", 1);
	print FILE "$ratesettings[0]\n";
	print FILE "$ratesettings[1]\n";
	print FILE "$ratesettings[2]\n";
	print FILE "0.00|0\n";
	print FILE "$ratesettings[4]\n";
	fclose(FILE);

	$yySetLocation = qq~$scripturl?action=rateshowpg;rtcal=$ratings{'ertcal'};editmode=new;start=$ratings{'start'}~;
	&redirectexit;
}

}


sub Rate2 {
my($key, $value);
while( ($key,$value) = each(%FORM) ) {
	$value =~ s~\A\s+~~;
	$value =~ s~\s+\Z~~;
	$value =~ s~[\n\r]~~g;
	$rating{$key} = $value;
}
$rating{'username'} = $username;
if($rating{'ratetype'} eq "ratetopic") {
	if($username eq 'Guest' && !$guest_rate) { &fatal_error($txt{'138'}); }
}
$thcomment = "";
$thdate = $date;
$thisrate = $rating{'rating'};
$thisrater = $rating{'username'};
if($thisrater eq "Guest") { $thisrater = $user_ip }
$thrater = $rating{'username'};

fopen(FILE, "$RatesDir/$rating{'filename'}.rate");
@ratesettings=<FILE>;
$ratenum = @ratesettings;
fclose(FILE);
chomp @ratesettings;

($rates, $rateclicks) = split(/\|/,$ratesettings[3]);
$raters = $ratenum - 5;
$newflag = 1;

if($thisrate == 0) {
	$comminfo = "norate";
	$newraters = $raters - 1;
	for($i=5; $i<$ratenum; $i++) {
		($therater, $oldrate, $trater, $tcomment, $tdate) = split(/\|/,$ratesettings[$i]);
		if($thisrater eq $therater) { $thisoldrate = $oldrate }
	}
	if($newraters < 1) {
		$newrate = 0.00;
	}
	else {
		$newrate = sprintf ("%.2f", ((($rates*$raters) - $thisoldrate)/$newraters));
	}
	$ratesclick .= qq($newrate|$rateclicks);

	fopen( FILE, ">$RatesDir/$rating{'filename'}.rate", 1);
	print FILE "$ratesettings[0]\n";
	print FILE "$ratesettings[1]\n";
	print FILE "$ratesettings[2]\n";
	print FILE "$ratesclick\n";
	print FILE "$ratesettings[4]\n";
	for($i=5; $i<$ratenum; $i++) {
		($therater, $oldrate, $trater, $tcomment, $tdate) = split(/\|/,$ratesettings[$i]);
		if($therater ne $thisrater) { 
			print FILE "$ratesettings[$i]\n";
		}
	}
	fclose(FILE);
} else {
	$comminfo = $rating{'filename'};
	for($i=5; $i<$ratenum; $i++) {
		($oldrater, $oldrate, $trater, $tcomment, $tdate) = split(/\|/,$ratesettings[$i]);
		if($thisrater eq $oldrater) {
			$ratesettings[$i] = "";
			$ratesettings[$i] .= qq($oldrater|$thisrate|$trater|$tcomment|$tdate);
			$newrate = sprintf ("%.2f", (((($rates*$raters) - $oldrate) + $thisrate)/$raters));
			$newflag = 0;
		}
	}
	if($newflag) {
		$newraters = $raters + 1;
		$newrate = sprintf ("%.2f", ((($rates*$raters) + $thisrate)/$newraters));
	}

	$ratesclick .= qq($newrate|$rateclicks);
	fopen( FILE, ">$RatesDir/$rating{'filename'}.rate", 1);
	print FILE "$ratesettings[0]\n";
	print FILE "$ratesettings[1]\n";
	print FILE "$ratesettings[2]\n";
	print FILE "$ratesclick\n";
	print FILE "$ratesettings[4]\n";
	if($newflag) {
		print FILE "$thisrater|$thisrate|$thrater|$thcomment|$thdate\n";
		for($i=5; $i<$ratenum; $i++) { print FILE "$ratesettings[$i]\n"; }
	} else {
		for($i=5 ; $i<$ratenum; $i++) { print FILE "$ratesettings[$i]\n"; }
	}
	fclose(FILE);
}

if($rating{'ratetype'} eq "rateex") {
	$yySetLocation = qq~$scripturl?action=rateoverview;rateid=$rating{'filename'};commentmode=$comminfo~;
}
elsif($rating{'ratetype'} eq "ratetopic") {
	$rateboard = $rating{'yabbcat'};
	$yySetLocation = qq~$scripturl?board=$rateboard;action=display;num=$rating{'filename'};commentmode=$comminfo#rating$rating{'filename'}~;
}
else {
	$yySetLocation = qq~$scripturl?action=rateshowpg;rtcal=$rating{'rcal'};editmode=new;commentmode=$comminfo;start=$rating{'start'}#$rating{'filename'}~;
}

&redirectexit;

}


sub Rate3 {
$FORM{'descrip'} =~ s~\n~\&\&~g;
my($key, $value);
while( ($key,$value) = each(%FORM) ) {
	$value =~ s~\A\s+~~;
	$value =~ s~\s+\Z~~;
	$value =~ s~[\n\r]~~g;
	$rating{$key} = $value;
}

if (!$rating{'ratestatus'}) { $rating{'ratestatus'} = 0; }

$rating{'username'} = $username;

$rating{'descrip'} =~ s/</&lt;/g;
$rating{'descrip'} =~ s/</&gt;/g;

if($rating{'link'} !~ m~\Ahttp://~ && $rating{'link'} ne "" && $rating{'link'} !~ m~\Aftp://~) { $rating{'link'} = "http://$rating{'link'}"; }

if($rating{'ratetest'} == 0) {

	$rateid = time;
	$i=0;
	if (-e "$RatesDir/$rateid.rate") {
		while (-e "$RatesDir/$rateid$i.rate") { ++$i; }
		$rateid="$rateid$i";
	}

	if($rating{'ratename'} eq "") { &fatal_error("$ratetxt{'14'}"); }
	if($rating{'ratecat'} eq "") { $rating{'ratecat'} = $rating{'catedit'}; }
	if($rating{'ratecat'} eq "") { &fatal_error("$ratetxt{'18'}"); }

	if(!-e ("$vardir/rateitlist.txt")) {
		fopen(FILE, ">$vardir/rateitlist.txt", 1);
		print FILE "|1|1|1\n";
		fclose(FILE);
	}

	fopen(FILE, "$vardir/rateitlist.txt");
	@ratelist = <FILE>;
	$listnum = @ratelist;
	fclose(FILE);

	$namestart = "";
	$namestart .= qq($rating{'ratename'}|$date|$rating{'ratestatus'});

	fopen( FILE, ">$RatesDir/$rateid.rate", 1);
	print FILE "$rating{'ratecatid'}|$rating{'ratecat'}\n";
	print FILE "$namestart\n";
	print FILE "$rating{'descrip'}\n";
	print FILE "0.00|0\n";
	print FILE "$rating{'link'}\n";
	fclose(FILE);


	fopen(FILE, ">$vardir/rateitlist.txt", 1);
	foreach $currate (@ratelist) {
		chomp $currate;
		print FILE "$currate\n";
	}
	print FILE "$rateid|$rating{'username'}|$rating{'ratecatid'}|$rating{'ratestatus'}\n";
	fclose(FILE);
} else {
	fopen(FILE, "$RatesDir/$rating{'rateid'}.rate");
	@ratesettings=<FILE>;
	$ratenum = @ratesettings;
	fclose(FILE);
	chomp @ratesettings;

	if($rating{'ratecat'} eq "") { $rating{'ratecat'} = $rating{'catedit'}; }
	if($rating{'catedit'} ne "new") { $rating{'ratecat'} = $rating{'catedit'}; }
	if($rating{'ratecat'} eq "") { &fatal_error("$ratetxt{'18'}"); }

	($thename, $thedate) = split(/\|/,$ratesettings[1]);
	$namestart = "";
	$namestart .= qq($rating{'ratename'}|$thedate|$rating{'ratestatus'});

	$num = $ratenum - 5;
	$z = 5;

		fopen(FILE, ">$RatesDir/$rating{'rateid'}.rate", 1);
		print FILE "$rating{'ratecatid'}|$rating{'ratecat'}\n";
		print FILE "$namestart\n";
		print FILE "$rating{'descrip'}\n";
		print FILE "$ratesettings[3]\n";
		print FILE "$rating{'link'}\n";
		for($i=0;$i<$num;$i++) {
			print FILE "$ratesettings[$z]\n";
			$z++;
		}
		fclose(FILE);
}

$yySetLocation = qq~$scripturl?action=rateshow;editmode=new;start=$rating{'start'}~;
&redirectexit;

}

sub RateComment {
$FORM{'message'} =~ s~\n~\&\&~g;
my($key, $value);
while( ($key,$value) = each(%FORM) ) {
	$value =~ s~\A\s+~~;
	$value =~ s~\s+\Z~~;
	$value =~ s~[\n\r]~~g;
	$rating{$key} = $value;
}

$thisrater = $rating{'username'};
if($thisrater eq "Guest") { $thisrater = $user_ip }
$thrater = $rating{'username'};

$rating{'message'} =~ s/</&lt;/g;
$rating{'message'} =~ s/</&gt;/g;

	fopen(FILE, "$RatesDir/$rating{'filename'}.rate");
	@ratesettings=<FILE>;
	$ratenum = @ratesettings;
	fclose(FILE);
	chomp @ratesettings;

	fopen( FILE, ">$RatesDir/$rating{'filename'}.rate", 1);
	print FILE "$ratesettings[0]\n";
	print FILE "$ratesettings[1]\n";
	print FILE "$ratesettings[2]\n";
	print FILE "$ratesettings[3]\n";
	print FILE "$ratesettings[4]\n";
	for($i=5;$i<$ratenum;$i++) {
		($therater, $therate, $trater, $tcomment, $tdate) = split(/\|/,$ratesettings[$i]);
		if($therater eq $thisrater) {
			print FILE "$therater|$therate|$thrater|$rating{'message'}|$date\n";
		}
		else {
			print FILE "$ratesettings[$i]\n";
		}
	}
	fclose(FILE);


if($rating{'ratetype'} eq "rateex") {
	if($rating{'start'} eq "nostart") {
		$yySetLocation = qq~$scripturl?action=rateoverview;rateid=$rating{'filename'};pagesback=-2~;
	}else {
		$yySetLocation = qq~$cgi;action=rateshowpg;rtcal=$rating{'rcal'};editmode=new;commentmode=$comminfo;start=$rating{'start'}#$rating{'filename'}~;
	}
} elsif ($rating{'ratetype'} eq "ratetopic") {
	$rateboard = $rating{'yabbcat'};
	if($rating{'start'} eq "nostart") {
		$yySetLocation = qq~$scripturl?num=$rating{'filename'};commentmode=$comminfo#rating$rating{'filename'}~;
	} else {
		$yySetLocation = qq~$scripturl?num=$rating{'filename'};rtcal=$rating{'rcal'};editmode=new;commentmode=norate;start=$rating{'start'}#$rating{'filename'}~;
	}
} else {
	$yySetLocation = qq~$scripturl?action=rateoverview;rateid=$rating{'filename'};pagesback=-2~;
}

&redirectexit;
}


sub CatJump {
my($key, $value);
while( ($key,$value) = each(%FORM) ) {
	$value =~ s~\A\s+~~;
	$value =~ s~\s+\Z~~;
	$value =~ s~[\n\r]~~g;
	$jumpcat{$key} = $value;
}
	($thepage, $thecatg) = split(/\|/,$jumpcat{'catjump'});
	$catname .= qq(cat$thecatg);
	$yySetLocation = qq~$scripturl?action=rateshowpg;rtcal=$jumpcat{'rcal'};start=$thepage;editmode=new#$catname~;
	&redirectexit;
}


sub ClickCount  {
	if($username eq "Guest" && !$guest_rate) { &fatal_error($txt{'138'}); }

	$ratelink = $INFO{'rateid'};

	fopen(FILE, "$RatesDir/$ratelink.rate");
	@ratesettings=<FILE>;
	$ratenum = @ratesettings;
	fclose(FILE);
	chomp @ratesettings;
	$num = $ratenum - 5;
	$z = 5;

  	($rates, $rateclicks) = split(/\|/,$ratesettings[3]);
	$rateclicks++;

	fopen(FILE,">$RatesDir/$ratelink.rate", 1);
		print FILE "$ratesettings[0]\n";
		print FILE "$ratesettings[1]\n";
		print FILE "$ratesettings[2]\n";
	 	print FILE ("$rates|$rateclicks\n");
		print FILE "$ratesettings[4]\n";
		for($i=0;$i<$num;$i++) {
			print FILE "$ratesettings[$z]\n";
			$z++;
		}
	fclose(FILE);

	$dirlink = $ratesettings[4];

	print "HTTP/1.0 302 Temporary Redirection\r\n" if $ENV{PERLXS} eq "PerlIS";
	print "Content-type: text/html\n";

	print "Location: $dirlink\n\n";

	exit;

}


sub RatingLink {
	@ratelist = ();
	fopen(FILE, "$vardir/rateitlist.txt");
	@ratelist = <FILE>;
	$ratecount = @ratelist;
	@ratenames = @ratelist;
	fclose(FILE);
	chomp(@ratenames);

	$rateitemcount = $ratecount - 1;
	$x = 0;

	$highclick = 0;
	$linkcount = 0;

	for($i=1; $i<$ratecount; $i++) {
		chomp(@ratenames);
		($ratenam, $rateusr, undef, undef) = split(/\|/, $ratenames[$i]);
		fopen(RATEFILE,"$RatesDir/$ratenam.rate");
		@raten = <RATEFILE>;
		fclose(RATEFILE);
		chomp(@raten);
		(undef, $ratenclick) = split(/\|/, $raten[3]);
		if($ratenclick > $highclick) { $highclick = $ratenclick }
		if($raten[4] ne "") { $linkcount++ }
	}

	$invclick = 999999;

	for($i=1; $i<$ratecount; $i++) {
		chomp(@ratenames);
		($ratenam, $rateusr) = split(/\|/, $ratenames[$i]);
		fopen(RATEFILE,"$RatesDir/$ratenam.rate");
		@rater = <RATEFILE>;
		fclose(RATEFILE);
		chomp(@rater);
		if($sort_rate == 1) {
			$ratesrt1 = $ratenam[$i];
			$ratesrt1 =~ s/ //gi;
			$ratesrt1 =~ s/\.//gi;
			$ratesrt1 =~ s/\-//gi;
			($ratercnt, undef) = split(/\|/, $rater[3]);
			$ratercnt = $ratercnt * 100;
			$ratesrt2 = 2000 - $ratercnt;
			($ratesrt3, undef, undef) = split(/\|/, $rater[1]);
			$ratesrt3 =~ s/ //gi;
			$ratesrt3 =~ s/\.//gi;
			$ratesrt3 =~ s/\-//gi;
		}
		elsif($sort_rate == 2) {
			$ratesrt1 = $ratenam[$i];
			$ratesrt1 =~ s/ //gi;
			$ratesrt1 =~ s/\.//gi;
			$ratesrt1 =~ s/\-//gi;
			($ratesrt2, undef, undef) = split(/\|/, $rater[1]);
			$ratesrt2 =~ s/ //gi;
			$ratesrt2 =~ s/\.//gi;
			$ratesrt2 =~ s/\-//gi;
			$ratesrt3 = "";
		}
		elsif($sort_rate == 3) {
			$ratesrt1 = $ratenam[$i];
			$ratesrt1 =~ s/ //gi;
			$ratesrt1 =~ s/\.//gi;
			$ratesrt1 =~ s/\-//gi;
			(undef, $rclick) = split(/\|/, $rater[3]);
			$ratesrt2 = $invclick - $rclick;
			($ratesrt3, undef, undef) = split(/\|/, $rater[1]);
			$ratesrt3 =~ s/ //gi;
			$ratesrt3 =~ s/\.//gi;
			$ratesrt3 =~ s/\-//gi;
		}
		elsif($sort_rate == 4) {
			($ratercnt, undef) = split(/\|/, $rater[3]);
			$ratercnt = $ratercnt * 100;
			$ratesrt1 = 2000 - $ratercnt;
			($ratesrt2, undef, undef) = split(/\|/, $rater[1]);
			$ratesrt2 =~ s/ //gi;
			$ratesrt2 =~ s/\.//gi;
			$ratesrt2 =~ s/\-//gi;
			$ratesrt3 = "";
		}
		elsif($sort_rate == 5) {
			($ratercnt, undef) = split(/\|/, $rater[3]);
			$ratercnt = $ratercnt * 100;
			$ratesrt2 = 2000 - $ratercnt;
			($ratesrt1, undef, undef) = split(/\|/, $rater[1]);
			$ratesrt1 =~ s/ //gi;
			$ratesrt1 =~ s/\.//gi;
			$ratesrt1 =~ s/\-//gi;
			(undef, $rclick) = split(/\|/, $rater[3]);
			$ratesrt3 = $invclick - $rclick;
		}
		elsif($sort_rate == 6) {
			(undef, $rclick) = split(/\|/, $rater[3]);
			$ratesrt1 = $invclick - $rclick;
			($ratesrt2, undef) = split(/\|/, $rater[1]);
			$ratesrt2 =~ s/ //gi;
			$ratesrt2 =~ s/\.//gi;
			$ratesrt2 =~ s/\-//gi;
			($ratercnt, undef, undef) = split(/\|/, $rater[3]);
			$ratercnt = $ratercnt * 100;
			$ratesrt3 = 2000 - $ratercnt;
		}
		$templist[$x] .= qq($ratesrt1|$ratesrt2|$ratenam);
		$x++;
	}

	@SortAItems = sort{lc($a) cmp lc($b)} (@templist);
	for($i=0;$i<$rateitemcount;$i++) {
		my($SortItems);
		chomp(@SortAItems);
		(undef, undef, $SortItems) = split(/\|/, $SortAItems[$i]);
		if($SortItems eq $INFO{'itemlink'}) {
			if($i < $RatesPerPage) { $itmstart = 0; }
			else { $itmstart = ( int($i / $RatesPerPage) ) * $RatesPerPage; }
		}
	}
	$yySetLocation = qq~$scripturl?action=rateshow;start=$itmstart;editmode=new#$INFO{'itemlink'}~;
	&redirectexit;
}


sub ItemOverview {

$rate = $INFO{'rateid'};

@rateinfo = ();
fopen(RATEFILEREAD,"$RatesDir/$rate.rate");
@rateinfo = <RATEFILEREAD>;
$lines = @rateinfo;
fclose(RATEFILEREAD);
chomp @rateinfo;

($rateinfoname, $rateinfodate, $rateinfostat) = split(/\|/,$rateinfo[1]);

$totalrate = 0;

if($INFO{'pagesback'} eq "") { $page_back = -1; }
else { $page_back = $INFO{'pagesback'} }

$thisuser = $username;
if($thisuser eq "Guest") { $thisuser = $user_ip; $a_guest = 1; }
$c = 0;
$commentnum = 0;
@thiscommenter = ();
@thiscomment = ();
@thisdate = ();
$comment = "";
$canrate = 1;
$raters = $lines - 5;
if($raters > 0) {
	for($i=5; $i < $lines; $i++) {
		$thiscommenter[$c] = "";
		$thiscomment[$c] = "";
		$thisdate[$c] = "";
		($thisrater, $thisrate, $thrater, $thiscomment[$c], $thisdate[$c]) = split(/\|/,$rateinfo[$i]);
		if($thisuser eq $thisrater) { 
			$thecomment = $thiscomment[$c];
		}
		$totalrate = $totalrate + $thisrate;
		$delrater[$c] = $thisrater;
		if($thiscomment[$c] ne "") { 
			$commentnum++;
			if($thrater ne "Guest") {
				$thmember = $thrater;
				&LoadUser($thmember);
				$thiscommenter[$c] .= qq~$link{$thmember}~;
			}
			else {
				$thiscommenter[$c] = "Guest";
			}
		}
			$c++;
	}
	$rating = sprintf ("%.2f", ($totalrate/$raters));
}
else { $rating = "0.00" }

$barrate = $rating * 10;
$ratebar = "";
$ratebar1 = "";
$ratebar2 = "";

$barchart = int($barrate);
$barchart1 = 100 - $barchart;
if ($barchart < 1) {$ratebar = "$ratebar";}
else { $ratebar = qq~<img src="$modimgurl/RateIT/ratebar.gif" width="$barchart" height="10" alt="" border="0" />~; }
if ($barchart > 99) {$ratebar1 = "$ratebar1";}
else { $ratebar1 = qq~<img src="$modimgurl/RateIT/ratebar1.gif" width="$barchart1" height="10" alt="" border="0" />~; }
$ratebar2 = qq~$ratebar$ratebar1~;

@barhight = ();
@itembar = ();
$maxhight = 0;
$y = 0;
for($x=1; $x<11; $x++) {
	$itembar[$y] = "";
	$barhight[$y] = 0;
	for($i=5; $i<$lines; $i++) {
		(undef, $therate, undef, undef, undef) = split(/\|/,$rateinfo[$i]);
		if($therate == $x) { $barhight[$y]++ }
	}
	if($barhight[$y] > $maxhight) { $maxhight = $barhight[$y] }
	if($barhight[$y] == 0) {
		$barhightdig[$y] = "&nbsp;";
	}
	else {
		$barhightdig[$y] = $barhight[$y];
	}

	$y++;
}

if($maxhight <= 5) {
	$maxhight = 5;
	$scaleincr = 1;
	for($i=0; $i<10; $i++) {
		$barhight[$i] = $barhight[$i] * 20;
	}
}
else {
	$tmpmaxhight = int($maxhight / 5);
	$tmpmaxhight = $tmpmaxhight + 1;
	$maxhight = $tmpmaxhight * 5;
	$scaleincr = $maxhight / 5;
	for($i=0; $i<10; $i++) {
		if($barhight[$i] > 0) {
			$bartemp = ($barhight[$i] * 100);
			$barhight[$i] = int(($bartemp / $maxhight) + 0.5);
		}
	}
}

$scaledig = $maxhight;
for($i=0; $i<5; $i++) {
		$barscaledig[$i] = $scaledig;
		$scaledig = $scaledig - $scaleincr;
}

for($y=0; $y<10; $y++) {
	$itembar[$y] = "";
	if($barhight[$y] == 0) {
		$itembar[$y] = qq~<img src="$modimgurl/RateIT/scalebarfill.gif" width="30" height="120" alt="" border="0" /><br />~;
	}
	else {
		$itembar[$y] = qq~<img src="$modimgurl/RateIT/scalebarfill.gif" width="10" height="120" alt="" border="0" /><img src="$modimgurl/RateIT/itembar.gif" width="10" height="$barhight[$y]" alt="$barhightdig[$y]" border="0"><img src="$modimgurl/RateIT/scalebarfill.gif" width="10" height="120" alt="" border="0"><br />~;
	}
}

$yymain .= qq~
<br /><br /><br />
<table border="0" cellspacing="1" width="60%" cellpadding="0" class="bordercolor" align="center">

	<tr><td width="100%">
		<table width="100%" border="0" cellspacing="0" cellpadding="4" align="center">
		<tr>
			<td width="100%" class="titlebg" align="left" colspan="2">
				<span class="text1"><b><img src="$modimgurl/RateIT/rate.gif" border="0" align="absmiddle" />$rateinfoname</b></span>
			</td>
		</tr>
		</table>
	</td></tr>

~;

	$descrip = $rateinfo[2];
	$descrip =~ s~\&\&~<br />~g;
	$message = $descrip;
	&wrap;
	if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
	&wrap2;

	$descrip = $message;

$yymain .= qq~

	<tr><td width="100%">
		<table width="100%" border="0" cellspacing="0" cellpadding="4" align="center">
		<tr>
			<td width="100%" class="windowbg" align="left">	<span class="small">$descrip</span></td>
		</tr>
		</table>
	</td></tr>


	~;

	if($allow_comment) {
		$yymain .= qq~
		<tr>
			<td class="windowbg2" valign="top">
				<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
				<div style="position: relative; top: 0px; left: 0px; height: 150px; padding-left: 7px; padding-top: 0px; padding-right: 7px; overflow: auto;">
				~;
				
				if(!$iamguest || $guest_rate) {

					if($INFO{'commentmode'} eq $rate) {
						$thecomment =~ s~\&\&~\n~g;
						$yymain .= qq~
						<span class="small">
						<b>$ratetxt{'62'}:</b><br />
						</span>
						<form action="$scripturl?action=ratecomment" method="post" name="postmodify">
						<table border="0" cellspacing="0" cellpadding="2" align="center">
						<tr><td valign="middle">
							<textarea name="message" cols="40" rows="4" wrap="soft" onclick="javascript:storeCaret(this);" onkeyup="javascript:storeCaret(this);" onchange="javascript:storeCaret(this);">$thecomment</textarea>
						</td><td valign="middle">
						<input style="width:80px;" value="$chars_comment" name="msgCL" disabled="disabled" /><br />
						<input style="width:80px;" type="submit" value="$ratetxt{'64'}" />
						<input type="hidden" name="filename" value="$rate" />
						<input type="hidden" name="username" value="$username" />
						<input type="hidden" name="start" value="nostart" />
						<script language="JavaScript1.2" type="text/javascript">
						<!--
							var supportsKeys = false
							function tick() {
								calcCharLeft(document.forms[0])
								if (!supportsKeys) timerID = setTimeout("tick()",$chars_comment)
							}

							function calcCharLeft(sig) {
								clipped = false
								maxLength = $chars_comment
								if (document.postmodify.message.value.length > maxLength) {
									document.postmodify.message.value = document.postmodify.message.value.substring(0,maxLength)
									charleft = 0
									clipped = true
							  	} 
								else {
									charleft = maxLength - document.postmodify.message.value.length
							  	}
								document.postmodify.msgCL.value = charleft
								return clipped
							}
							tick();
						//-->
						</script>
						</td></tr>
						</table>
						</form>
						~;
					}
				}
				
				$yymain .= qq~<span class="small"><br /><b>$ratetxt{'61'}:</b> $commentnum<br /></span>~;
				
				for($i=0; $i<$raters; $i++) {
					$comment = $thiscomment[$i];
					if($comment ne "") {
						$pthisdate = &timeformat($thisdate[$i]); 
						&LoadCensorList;
						$comment   = &Censor($comment);
						$comment =~ s~\&\&~<br />~g;
						if($ubbc_comment) {
							$message = $comment;
							$char_160 = chr(160);
							$message =~ s~\[img\][\s*\t*\n*(&nbsp;)*($char_160)*]*(http\:\/\/)*(.+?)[\s*\t*\n*(&nbsp;)*($char_160)*]*\[/img\]~\[url=http\:\/\/$2\]\[img\]$imagesdir/img2.gif\[\/img\]\[\/url\]~isg;
							&wrap;
							if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
							&wrap2;
							$comment = $message;
						}
						
						$yymain .= qq~<span class="small"><b>$thiscommenter[$i]</b> - $pthisdate<br />$comment</span><br />~;
						
						if ($iamadmin || $iamgmod) {
						$yymain .= qq~<a href="$scripturl?action=ratedelcomment;rater=$delrater[$i];name=$rate;start=nostart"><img src="$imagesdir/im_delete.gif" border="0" align="absmiddle" alt="$ratetxt{'12'}" /></a><br />~;
						}
						$yymain .= qq~
						<br />
						~;
					}

					}
				$yymain .= qq~
				</div>

				</td>
		</tr>
	~;
	}

$yymain .= qq~

	<tr><td width="100%">
		<table width="100%" border="0" cellspacing="0" cellpadding="4" align="center">
		<tr>
			<td width="40%" class="catbg" align="center">	$ratetxt{'05'}</td>
			<td width="60%" class="catbg" align="center">	$ratetxt{'02'}</td>
		</tr>
		<tr>
			<td width="40%" class="windowbg" align="center" valign="middle">
				$raters
			</td>
			<td width="60%" class="windowbg" align="center">
				<table border="0" width="160" cellspacing="0" cellpadding="2" align="center">
				<tr>
					<td width="50" align="right" valign="middle">$rating</td>
					<td width="110" align="left" valign="middle">$ratebar2</td>
				</tr>
				</table>
			</td>
		</tr>
		</table>
	</td></tr>

	<tr><td width="100%">
		<table width="100%" border="0" cellspacing="0" cellpadding="4" align="center">
		<tr>
			<td class="catbg" align="center">$ratetxt{'34'}	</td>
		</tr>
		</table>
	</td></tr>

	<tr><td width="100%">
		<table width="100%" border="0" cellspacing="0" cellpadding="0" align="center">

		<tr>
		<td class="windowbg" align="right">
			<table border="0" cellspacing="0" cellpadding="0" align="right">
				<tr>
					<td align="center" valign="middle"><img src="$modimgurl/RateIT/scalebott.gif" width="5" height="10" alt="" border="0" align="absmiddle" /><br /></td>
				</tr>
				~;
				for($i=0;$i<5;$i++) {
				$yymain .= qq~
				<tr>
					<td align="right" valign="middle"><span class="small">$barscaledig[$i]</span><img src="$modimgurl/RateIT/scalefill.gif" width="5" height="20" alt="" border="0" align="absmiddle" /><br /></td>
				</tr>
				~;
				}
				$yymain .= qq~
				<tr>
					<td align="center" valign="middle"><img src="$modimgurl/RateIT/scalebott.gif" width="5" height="10" alt="" border="0" align="absmiddle" /><br /></td>
				</tr>
			</table>
		</td>

		~;
		for($i=0;$i<10;$i++) {
		$yymain .= qq~
		<td class="windowbg" background="$modimgurl/RateIT/scalebg.gif" align="center" valign="bottom">
			$itembar[$i]
		</td>
		~;
		}
		$yymain .= qq~
		<td class="windowbg" align="left">
			<table border="0" cellspacing="0" cellpadding="0" align="left">
				<tr>
					<td align="center" valign="middle"><img src="$modimgurl/RateIT/scalebott.gif" width="5" height="10" alt="" border="0" align="absmiddle" /><br /></td>
				</tr>
				~;
				for($i=0;$i<5;$i++) {
				$yymain .= qq~
				<tr>
					<td align="left" valign="middle"><img src="$modimgurl/RateIT/scalefill1.gif" width="5" height="20" alt="" border="0" align="absmiddle" /><span class="small">$barscaledig[$i]</span><br /></td>
				</tr>
				~;
				}
				$yymain .= qq~
				<tr>
					<td align="center" valign="middle"><img src="$modimgurl/RateIT/scalebott.gif" width="5" height="10" alt="" border="0" align="absmiddle" /><br /></td>
				</tr>
			</table>
		</td>

		</tr>
		<tr>
		<td class="catbg" align="center">
			<img src="$modimgurl/RateIT/scalecol.gif" width="30" height="4" alt="" border="0" />
		</td>
		~;
		for($i=0;$i<10;$i++) {
		$ratedig = $i + 1;
		$yymain .= qq~
		<td class="catbg" align="center">
			<img src="$modimgurl/RateIT/scalecol.gif" width="30" height="4" alt="" border="0" /><br />$ratedig<br /><img src="$modimgurl/RateIT/scalecol.gif" width="30" height="4" alt="" border="0" /><br />
		</td>
		~;
		}
		$yymain .= qq~
		<td class="catbg" align="center">
			<img src="$modimgurl/RateIT/scalecol.gif" width="30" height="4" alt="" border="0" />
		</td>
		</tr>
		</table>
	</td></tr>

</table>
<p align="center"><br /><a href="javascript:history.go($page_back)">$ratetxt{'142'}</a></p>
~;

$yytitle = "$ratetxt{'33'}";
&template;
exit;

}

sub RatingTopic {
my $mstate = $_[0];

### Rating ###
		my ($rateicon);
		if ($mstate !~ /l/i ) { 
			$rateicon = 'rate';
		} else {
			$rateicon = 'ratelock';
		}

		fopen(FILE, "$vardir/rateitlist.txt");
		@ratelist = <FILE>;
		fclose(FILE);

		fopen(FILE, ">$vardir/rateitlist.txt", 1);
		foreach $currate (@ratelist) {
			chomp $currate;
			($thiscurrate, $thiscurusr, $thiscurbrd, $thiscurstate) = split(/\|/, $currate);
			if($thiscurrate ne $viewnum) { 
				print FILE "$currate\n";
			} else {
				print FILE "$thiscurrate|$thiscurusr|$thiscurbrd|$mstate\n";
			}
		}
		fclose(FILE);

		@rateinfo = ();
		fopen(RATEFILEREAD,"$RatesDir/$viewnum.rate");
		@rateinfo = <RATEFILEREAD>;
		$lines = @rateinfo;
		fclose(RATEFILEREAD);
		chomp @rateinfo;
		
		($thisname, $thistm5, $thisrst) = split(/\|/,$rateinfo[1]);
		
		if ($mstate ne $thisrst) {		
			$num = $lines - 2;
			$z = 2;
			fopen(FILE, ">$RatesDir/$viewnum.rate", 1);
			print FILE "$rateinfo[0]\n";
			print FILE "$thisname|$thistm5|$mstate\n";
			for($i=0; $i<$num; $i++) {
				print FILE "$rateinfo[$z]\n";
				$z++;
			}
			fclose(FILE);
		}
		
		$thisuser = $username;
		if($thisuser eq "Guest") { $thisuser = $user_ip }
		$c = 0;
		$commentnum = 0;
		@thiscommenter = ();
		@thiscomment = ();
		@thisdate = ();
		$comment = "";
		$canrate = 1;
		$raters = $lines - 5;
		if($raters > 0) {
			for($i=5; $i < $lines; $i++) {
				($thisrater, $thisrate, $thrater, $thiscomment[$c], $thisdate[$c]) = split(/\|/,$rateinfo[$i]);
				if($thisuser eq $thisrater) { 
					$intrate = int($thisrate);
					$check[$intrate] = "selected";
					$thecomment = $thiscomment[$c];
				}
				$totalrate = $totalrate + $thisrate;
				$delrater[$c] = $thisrater;
				if($thiscomment[$c] ne "") { 
					$commentnum++;
					if($thrater ne "Guest") {
						$thmember = $thrater;
						&LoadUser($thmember);
						$thiscommenter[$c] .= qq~$link{$thmember}~;
					} else {
						$thiscommenter[$c] = "Guest";
					}
				}
			$c++;				
			}
			$therate = sprintf ("%.2f", ($totalrate/$raters));
		}
		else { $therate = "0.00" }

		($rating, $clicks) = split(/\|/,$rateinfo[3]);
		$barrate = $rating * 10;
		$ratebar = "";
		$ratebar1 = "";
		$ratebar2 = "";
		$barchart = int($barrate);
		$barchart1 = 100 - $barchart;
		
		if ($barchart < 1) {
			$ratebar = "$ratebar";
		} else {
			$ratebar = qq~<img src="$modimgurl/RateIT/ratebar.gif" width="$barchart" height="10" alt="" border="0" align="absmiddle" />~;
		}
		
		if ($barchart > 99) {
			$ratebar1 = "$ratebar1";
		} else {
			$ratebar1 = qq~<img src="$modimgurl/RateIT/ratebar1.gif" width="$barchart1" height="10" alt="" border="0" align="absmiddle" />~;
		}

		$ratebar2 = qq~$ratebar$ratebar1~;
		
		if ($opnrate_window) { $opnratew = 'target="_blank"' }
		$ratebar2 = qq~<a href="$scripturl?action=rateoverview;rateid=$viewnum">$ratebar2</a>~;

		@barhight = ();
		@itembar = ();
		$maxhight = 0;
		$y = 0;
		for($x=1; $x<11; $x++) {
			$itembar[$y] = "";
			$barhight[$y] = 0;
			for ($i=5; $i<$lines; $i++) {
				(undef, $otherate, undef, undef, undef) = split(/\|/,$rateinfo[$i]);
				if ($otherate == $x) { $barhight[$y]++ }
			}
			if ($barhight[$y] > $maxhight) { $maxhight = $barhight[$y] }
			
			if ($barhight[$y] == 0) {
				$barhightdig[$y] = "&nbsp;";
			} else {
				$barhightdig[$y] = $barhight[$y];
			}

			$y++;
		}

		if($maxhight <= 5) {
			$maxhight = 5;
			$scaleincr = 1;
			for($i=0; $i<10; $i++) {
				$barhight[$i] = $barhight[$i] * 20;
			}
		} else {
			$tmpmaxhight = int($maxhight / 5);
			$tmpmaxhight = $tmpmaxhight + 1;
			$maxhight = $tmpmaxhight * 5;
			$scaleincr = $maxhight / 5;
			for ($i=0; $i<10; $i++) {
				if ($barhight[$i] > 0) {
					$bartemp = ($barhight[$i] * 100);
					$barhight[$i] = int(($bartemp / $maxhight) + 0.5);
				}
			}
		}

		$scaledig = $maxhight;
		for ($i=0; $i<5; $i++) {
				$barscaledig[$i] = $scaledig;
				$scaledig = $scaledig - $scaleincr;
		}

		for ($y=0; $y<10; $y++) {
			$itembar[$y] = "";
			if($barhight[$y] == 0) {
				$itembar[$y] = qq~<img src="$modimgurl/RateIT/scalebarfill.gif" width="30" height="120" alt="" border="0" /><br />~;
			} else {
				$itembar[$y] = qq~<img src="$modimgurl/RateIT/scalebarfill.gif" width="10" height="120" alt="" border="0" /><img src="$modimgurl/RateIT/itembar.gif" width="10" height="$barhight[$y]" alt="$barhightdig[$y]" border="0" /><img src="$modimgurl/RateIT/scalebarfill.gif" width="10" height="120" alt="" border="0" /><br />~;
			}
		}
		
$yymainrating .= qq~
<a name="rating$viewnum"></a>
<table border="0" width="100%" cellspacing="1" cellpadding="4" class="bordercolor" align="center">
	<tr>
		<td valign="middle" align="left" class="titlebg">&nbsp;<img src="$modimgurl/RateIT/$rateicon.gif" alt="" align="absmiddle" /> <span class="text1">$ratetxt{'02'}</span></td>
	</tr>
  	<tr>
		<td class="windowbg2" colspan="2">
			<table width="100%" cellpadding="4" cellspacing="0">
~;
		
		if($rateinfo[2] ne "") {
			$descrip = $rateinfo[2];
			$descrip =~ s~\&\&~<br />~g;
			$message = $descrip;
			&wrap;
			if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
			&wrap2;
			$descrip = $message;
			$yymainrating .= qq~
			<tr>
				<td class="windowbg" colspan="2" align="left"><span class="small">$descrip</span></td>
			</tr>
			~;
		}
		
		$yymainrating .= qq~
			<tr>
				<td align="left" width="30%" class="windowbg2">
					<table border="0" cellspacing="0" cellpadding="4" align="left">
					<tr>
						<td align="left" valign="middle"><b>$ratetxt{'03'}:</b></td>
		~;
				
				if(!$iamguest || $guest_rate) {
					
					if ($mstate !~ /l/i ) {
					$yymainrating .= qq~
						<form method="post" action="$scripturl?action=ratesett2" name="$viewnum">
						<input type="hidden" name="filename" value="$viewnum" />
						<input type="hidden" name="username" value="$username" />
						<input type="hidden" name="yabbcat" value="$currentboard" />
						<input type="hidden" name="ratetype" value="ratetopic" />
						<td align="left">
						<select name="rating" onChange="submit(); return true">
							<option value="0" $check[0]>---</option>
							<option value="10" $check[10]>10 $ratetxt{'48'}</option>
							<option value="9" $check[9]>9</option>
							<option value="8" $check[8]>8</option>
							<option value="7" $check[7]>7</option>
							<option value="6" $check[6]>6</option>
							<option value="5" $check[5]>5</option>
							<option value="4" $check[4]>4</option>
							<option value="3" $check[3]>3</option>
							<option value="2" $check[2]>2</option>
							<option value="1" $check[1]>1</option>
						</select>
						</td>
						</form>
					</tr>
					~;
					} else {
					$yymainrating .= qq~
						<td align="left" valign="middle"><img src="$modimgurl/RateIT/ratelock.gif" border="0" align="absmiddle" alt="$txt{'456'}" /></td>
					</tr>
					~;
					}
					
				} else {
					$yymainrating .= qq~
						<td align="left" valign="middle"><img src="$imagesdir/ban.gif" border="0" align="absmiddle" alt="$ratetxt{'21'}" /></td>
					</tr>
					~;
				}
				
				$yymainrating .= qq~
					<tr>
						<td align="left" valign="middle"><b>$ratetxt{'02'}:</b></td>
						<td align="left" valign="middle">$ratebar2</td>
					</tr><tr>
						<td align="left" valign="middle"><b>$ratetxt{'02'}:</b></td>
						<td align="left" valign="middle">$therate</td>
					</tr><tr>
						<td align="left" valign="middle"><b>$ratetxt{'05'}:</b></td>
						<td align="left" valign="middle">$raters</td>
					</tr>
					</table>
				</td>
				<td align="left" class="windowbg2">
					<table width="400" border="0" cellspacing="0" cellpadding="0" align="center">
					<tr>
						<td class="windowbg" align="right">
							<table border="0" cellspacing="0" cellpadding="0" align="right">
							<tr>
								<td align="center" valign="middle"><img src="$modimgurl/RateIT/scalebott.gif" width="5" height="10" alt="" border="0" align="absmiddle" /><br /></td>
							</tr>
				~;
				
				for($i=0; $i<5; $i++) {
				$yymainrating .= qq~
							<tr>
								<td align="right" valign="middle"><span class="small">$barscaledig[$i]</span><img src="$modimgurl/RateIT/scalefill.gif" width="5" height="20" alt="" border="0" align="absmiddle" /><br /></td>
							</tr>
				~;
				}
				
				$yymainrating .= qq~
							<tr>
								<td align="center" valign="middle"><img src="$modimgurl/RateIT/scalebott.gif" width="5" height="10" alt="" border="0" align="absmiddle" /><br /></td>
							</tr>
							</table>
						</td>
				~;
				
				for($i=0; $i<10; $i++) {
					$yymainrating .= qq~
						<td class="windowbg" background="$modimgurl/RateIT/scalebg.gif" align="center" valign="bottom">$itembar[$i]</td>
					~;
				}
		
				$yymainrating .= qq~
						<td class="windowbg" align="left">
							<table border="0" cellspacing="0" cellpadding="0" align="left">
							<tr>
								<td align="center" valign="middle"><img src="$modimgurl/RateIT/scalebott.gif" width="5" height="10" alt="" border="0" align="absmiddle" /><br /></td>
							</tr>
				~;
				
				for($i=0; $i<5; $i++) {
					$yymainrating .= qq~
							<tr>
								<td align="left" valign="middle"><img src="$modimgurl/RateIT/scalefill1.gif" width="5" height="20" alt="" border="0" align="absmiddle" /><span class="small">$barscaledig[$i]</span><br /></td>
							</tr>
					~;
				}
				
				$yymainrating .= qq~
							<tr>
								<td align="center" valign="middle"><img src="$modimgurl/RateIT/scalebott.gif" width="5" height="10" alt="" border="0" align="absmiddle" /><br /></td>
							</tr>
							</table>
						</td>
					</tr>
					<tr>
						<td class="windowbg" align="center">
								<img src="$modimgurl/RateIT/scalecol.gif" width="30" height="4" alt="" border="0" />
						</td>
				~;
		
		for($i=0; $i<10; $i++) {
		$ratedig = $i + 1;
			$yymainrating .= qq~
						<td class="windowbg" align="center">
							<img src="$modimgurl/RateIT/scalecol.gif" width="30" height="4" alt="" border="0" /><br /><b>$ratedig</b><br /><img src="$modimgurl/RateIT/scalecol.gif" width="30" height="4" alt="" border="0" /><br />
						</td>
			~;
		}
		
			$yymainrating .= qq~
						<td class="windowbg" align="center">
							<img src="$modimgurl/RateIT/scalecol.gif" width="30" height="4" alt="" border="0" />
						</td>
					</tr>
					</table>
				</td>
			</tr>
			</table>
		</td>
	</tr>
			~;			



if($allow_tcomment) {
	$yymainrating .= qq~
  	<tr>
		<td class="windowbg2" colspan="2"><p align="center" class="small"><b>$ratetxt{'61'}:</b> $commentnum</p></td>
	</tr>
	<tr>
		<td class="windowbg" colspan="2">
			<table width="100%" cellpadding="4" cellspacing="0">
			<tr>
				<td class="windowbg" valign="top">
				<div style="position: relative; display: block; table-layout: fixed; top: 0px; left: 0px; height: 150px; width: 98%; padding-left: 7px; padding-top: 0px; padding-right: 7px; overflow: auto;" class="windowbg2">
				<script language="JavaScript1.2" src="$ubbcjspath" type="text/javascript"></script>
	~;
						
				if((!$iamguest || $guest_rate) && $INFO{'commentmode'} eq $viewnum) {
				$thecomment =~ s~\&\&~\n~g;
				$settofield = "message";
				$yymainrating .= qq~
				<form action="$scripturl?action=ratecomment" method="post" name="postmodify2">
				<span class="small"><b>$ratetxt{'62'}:</b><br /></span>
				<table border="0" cellspacing="0" cellpadding="2" align="center">
				<tr>
					<td valign="middle">
					<textarea name="message" cols="80" rows="9" wrap="soft" style="height: 100px; width: 500px; padding: 5px; margin: 0px; visibility: visible;" onclick="javascript:storeCaret(this);" onkeyup="javascript:storeCaret(this);" onchange="javascript:storeCaret(this);">$thecomment</textarea>
					</td>
					<td valign="middle">
					<img src="$imagesdir/green1.gif" name="chrwarn2" height="8" width="8" border="0" vspace="0" hspace="0" alt="" align="middle" />
        				<font size="1">$ratetxt{'120'}<input value="$chars_comment" size="3" name="msgCL2" class="windowbg2" style="border: 0px; font-size: 10px; width: 40px; padding: 1px" readonly="readonly" /></font><br />
					<input type="hidden" name="filename" value="$viewnum" />
					<input type="hidden" name="username" value="$username" />
					<input type="hidden" name="start" value="$start" />
					<input type="hidden" name="rcal" value="$ratecal" />
					<input type="submit" value="$ratetxt{'64'}" style="width: 100px;" />
					<script language="JavaScript1.2" type="text/javascript">
					<!--
					var noalert2 = true, gralert2 = false, rdalert2 = false, clalert2 = false;
					var prevsec2 = 5
					var prevtxt2
					var cntsec2 = 0
					
					function tick2() {
					  cntsec2++
					  calcCharLeft2()
					  timerID2 = setTimeout("tick2()",1000)
					}
					
					var autoprev2 = false
					var topicfirst2 = true;
					
					function calcCharLeft2() {
					  clipped2 = false
					  maxLength2 = $chars_comment
					  if (document.postmodify2.message.value.length > maxLength2) {
						document.postmodify2.message.value = document.postmodify2.message.value.substring(0,maxLength2)
						charleft2 = 0
						clipped2 = true
					  } else {
						charleft2 = maxLength2 - document.postmodify2.message.value.length
					  }
					  prevsec2++
					  strLength2 = maxLength2 / 2
					  strLength22 = maxLength2 / 4
					  document.postmodify2.msgCL2.value = charleft2
					  
					  if (charleft2 >= strLength2 && noalert2) { noalert2 = false; gralert2 = true; rdalert2 = true; clalert2 = true; document.images.chrwarn2.src="$imagesdir/green1.gif"; }
					  if (charleft2 < strLength2 && charleft2 >= strLength22 && gralert2) { noalert2 = true; gralert2 = false; rdalert2 = true; clalert2 = true; document.images.chrwarn2.src="$imagesdir/green0.gif"; }
					  if (charleft2 < strLength22 && charleft2 > 0 && rdalert2) { noalert = true; gralert = true; rdalert = false; clalert = true; document.images.chrwarn2.src="$imagesdir/red0.gif" }
					  if (charleft2 == 0 && clalert2) { noalert2 = true; gralert2 = true; rdalert2 = true; clalert2 = false; document.images.chrwarn2.src="$imagesdir/red1.gif"; }
					  return clipped2
					}

					tick2();   
					//-->
					</script>
					</td>
				</tr>
				</table>
				</form>
				~;
				}

				for($i=0; $i<$raters; $i++) {
					$comment = $thiscomment[$i];
					if($comment ne "") {
						$pthisdate = &timeformat($thisdate[$i]);
						&LoadCensorList;
						$comment   = &Censor($comment);
						$comment =~ s~\&\&~<br />~g;
						if($ubbc_comment) {
							$message = $comment;
							$char_160 = chr(160);
							$message =~ s~\[img\][\s*\t*\n*(&nbsp;)*($char_160)*]*(http\:\/\/)*(.+?)[\s*\t*\n*(&nbsp;)*($char_160)*]*\[/img\]~\[url=http\:\/\/$2\]\[img\]$imagesdir/img2.gif\[\/img\]\[\/url\]~isg;
							&wrap;
							if($enable_ubbc) { if(!$yyYaBBCloaded) { require "$sourcedir/YaBBC.pl"; } &DoUBBC; }
							&wrap2;
							$comment = $message;
						}
						$yymainrating .= qq~
						<font size="1">
						<u><b>$thiscommenter[$i]</b></u> - $pthisdate<br />
						$comment
						</font><br />
						~;
						if ($iamadmin || $iamgmod) {
						$yymainrating .= qq~
							<a href="$scripturl?action=ratedelcomment;rater=$delrater[$i];name=$viewnum;start=nostart"><img src="$imagesdir/im_delete.gif" border="0" align="absmiddle" alt="$ratetxt{'12'}" /></a>
							<br />
						~;
						}
						$yymainrating .= qq~
						<br />
						~;
					}

					}
	
	$yymainrating .= qq~
	</div>
	</td>
	</tr>
	</table>
	~;
}


$yymainrating .= qq~
		</td>
	</tr>
</table>
~;

### Rating ###


}


1;